/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#ifndef CMD_H
#define CMD_H
extern const char* active_file;
extern int show_active_file;

struct COMMAND {
  const char* command;
  void (*handler)(const char* command, int extension);
  const int extension;
  const char* doc;
  const char* requires;
  const char* prereq;
  const char* example;
  const char* other_info;
  int want_ident:1;
  int want_file:1;
  int is_help:1;
};

extern struct COMMAND* opts;
extern int opts_len;


int run_command(const char*);
void init();
void end_file();
void clear_and_reset();

#endif
