/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#ifndef CMD_AUXILIARY_H
#define CMD_AUXILIARY_H
static xalloc_context temp_strings_context;
static void get_identifier(const char* command,char** ident)
{
  *ident=0;
  const char* str=command;
  while(*str==' ' || *str=='\t') str++;
  command=str;
  int i;
  for(i=0;
      *str!='\0'
	&& *str!=' '
	&& *str!='\t'
	&& *str!='\n';
      i++,str++);

  xalloc_context* context = xalloc_get_context();
  xalloc_set_context(&temp_strings_context);
  *ident = (char*) xalloc(i+1);
  xalloc_set_context(context);


  memcpy(*ident,command,i);
  *(*ident+i)=0;
  command=str;
}

static void filename(const char* command,char** fname)
{
  *fname=0;
  const char* str=command;
  while(*str==' ' || *str=='\t') str++;
  command=str;
  int i;
  for(i=0;
      *str!='\0'
	&& *str!=' '
	&& *str!='\t'
	&& *str!='\n';
      i++,str++);
  xalloc_context* context = xalloc_get_context();
  xalloc_set_context(&temp_strings_context);
  (*fname) = (char*) xalloc(i+1);
  xalloc_set_context(context);
  memcpy(*fname,command,i);
  *(*fname+i)=0;
  command=str;
}

static void macro_filename(const char* command,char** macro,char** filename)
{
  *macro=*filename=0;
  const char* str=command;
  while(*str==' ' || *str=='\t') str++;
  command=str;
  int i;
  for(i=0;
      *str!='\0'
	&& *str!=' '
	&& *str!='\t'
	&& *str!='\n';
      i++,str++);
  xalloc_context* context = xalloc_get_context();
  xalloc_set_context(&temp_strings_context);
  (*macro) = (char*) xalloc(i+1);
  xalloc_set_context(context);
  memcpy(*macro,command,i);
  *(*macro+i)=0;
  command=str;
  for( ; *str==' ' || *str=='\t' ; str++);
  while(*str==' ' || *str=='\t') str++;
  command=str;

  for(i=0;
      *str!='\0'
	&& *str!=' '
	&& *str!='\t'
	&& *str!='\n';
      i++,str++);
  if (!i) return;
  xalloc_set_context(&temp_strings_context);
  *filename = (char*) xalloc(i+1);
  xalloc_set_context(context);
  memcpy(*filename,command,i);
  *(*filename+i)=0;
  command=str;
}


static char* name_line_pos(const char* command, char** name, int* line, int* pos)
{
  const char* str=command;
  while(*str==' ' || *str=='\t') str++;
  command=str;

  int i;
  for(i=0;
      *str!='\0'
	&& *str!=' '
	&& *str!='\t'
	&& *str!='\n';
      i++,str++);
  xalloc_context* context = xalloc_get_context();
  xalloc_set_context(&temp_strings_context);
  *name = (char*) xalloc(i+1);
  xalloc_set_context(context);

  memcpy(*name,command,i);
  *(*name+i)=0;
  command=str;
  for( ; *str==' ' || *str=='\t' ; str++);
  char* c;
  *line=strtol(str,&c,0);
  str=c;
  for(i=0 ; *str==' ' || *str=='\t' ; str++);
  *pos=strtol(str,&c,0);
  return c;
}

static void clean_temp_strings_context()
{
  xalloc_context* context = xalloc_get_context();
  xalloc_set_context(&temp_strings_context);
  xfree_all();
  xalloc_set_context(context);
}



#endif
