/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>

	patched by sofolo - Solofo.Ramangalahy@free.fr
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#ifndef CMD_COMMANDS_H
#define CMD_COMMANDS_H
#include "database/fagin.h"
#include "database/database.h"
#include "base/macros.h"
extern void   set_check_inserted(); /* fagin.c */
static void build_file_command  (const char* command, int update)
{
  if (!database_opened(1)) return;
  const char* file=command;
  while(*file==' ' || *file=='\t') file++;
  command=file;
  int i;
  for(i=0;
           *file != '\0'
	&& *file != ' '
	&& *file != '\t'
	&& *file != '\n';
      i++,file++);

  static char fle[MAX_LEN];
  char *fname = fle;
  memset(fname,0,MAX_LEN);
  filename(command,&fname);

  char* f = fname;

  build_init();
  if      (update==0)   
    {
      build_one  (f);
    }
  else if (update==1)   
    {
      update_one (f);
    }
  else if (update==2)
    {
      const char* arg[] = { f, 0 };
      database_delete_file(arg);
    }
  else ABORT
  // build_file(command);

  set_check_inserted() ;
  build_one_save();
  build_destroy();
  unset_check_inserted() ;

#ifdef TEST_DELETE_FILE
  #warning pro ladici ucely zaznamy opet mazu
  database_delete_file(f);
#endif
}

extern void init_functions(); // interface/add-fce.h

static void  nosave_command(const char* command, int unused)
{
  init_functions();
  process_filelist(0);
}
extern FILE    *sparse_output;
static void sparse_output_command(const char* command, int unused)
{
  char * file;
  filename(command,&file);
  sparse_output=fopen(file,"wt");

}

static void get_unused_function_def_command(const char* unused1, int unused2)
{
  if (mem_build)     mem_find_unused_function_def();
  else               database_find_unused_function_def();
}

static void get_unused_variable_command(const char* unused1, int unused2)
{
  if (mem_build)     mem_find_unused_variable();
  else               database_find_unused_variable();
}

#if 0
static void get_unused_include_command(const char* unused1, int unused2)
{
  if (mem_build)    mem_find_unused_include();
  else              database_find_unused_include();
}
#endif

extern int system_includes_only; // bug fix ... too be corrected
static void system_includes_command(const char* command, int unused)
{
  system_includes_only=1;
}

static void exit_command  (const char* command, int unused)
{
#ifdef MY_WARNS
#warning not save
#endif
  database_end();
  if (verbose_spot) printf("bye\n");
  exit(0);
}

static void nsi_command  (const char* command, int unused)
{
  no_system_includes=1;
}

static void verbose_command  (const char* command, int unused)
{
  verbose_spot=1;
}

static void process_command  (const char* command, int unused)
{
  if (!spot_config_filename)
    {
      printf("No file list loaded\n");
      return;
    }
  int ai=test_already_inserted;
  test_already_inserted=1;
  build_init();
  if (!database_opened(1)) return;

  updating=1; building=1; deleting=1;
  process_filelist(1);
  build_update_save();
  build_destroy();
  updating=0; building=0; deleting=0;

  test_already_inserted=ai;

}

static void get_symbol_use_command   (const char* command, int unused)
{
  char *ident;
  get_identifier(command,&ident);
  print_bad_result=0;
  if (mem_build)
    {
      get_mem_macro_def(ident);
      get_mem_function_dec(ident);
      get_mem_function_def(ident);
      get_mem_function_use (ident);
      get_mem_variable_dec(ident);
      get_mem_variable_use(ident);
      get_mem_struct_dec(ident);
      get_mem_struct_def(ident);
      get_mem_struct_use(ident);
      get_mem_typedef_(ident);
      get_mem_typedef_use(ident);
    }
  else if (database_opened(1))
    {
      get_database_function_dec(ident);
      get_database_macro_def(ident);
      get_database_function_def(ident);
      get_database_function_use (ident);
      get_database_variable_dec(ident);
      get_database_variable_use(ident);
      get_database_struct_dec(ident);
      get_database_struct_def(ident);
      get_database_struct_use(ident);
      get_database_typedef_(ident);
      get_database_typedef_use(ident);  
    }
  print_bad_result=1;
}

#include <regex.h>
static void regexp_command  (const char* command, int unused)
{
  char *regexp;
  const char* str;
  regex_t re;
  int error;
  get_identifier(command,&regexp);
  error = regcomp (&re, regexp, REG_EXTENDED);
  if (error)
  {
      size_t errmsgsz;
      errmsgsz = regerror(error, &re, NULL,0);
      char *errmsg = malloc(errmsgsz);
      regerror(error, &re, errmsg, errmsgsz);
      fprintf(stderr, "regcomp: %s\n", errmsg);
      free(errmsg);
      regfree(&re);
      exit(1);
  }
  if (mem_build)
    {
      mem_generator_next_string(1);
      while ((str=mem_generator_next_string(0)))
	{
	  if (! regexec (&re
			 , str
			 , 0
			 , 0
			 , 0) )
	    printf("%s\n",str);
	}
    }
  else if (database_opened(0))
    {
      db_generator_next_string(1);
      while ((str=db_generator_next_string(0)))
	{
	  if (! regexec (&re
			 , str
			 , 0
			 , 0
			 , 0) )
	    printf("%s\n",str);
	}
    }
  regfree (&re);
}

void set_macros_file(const char* m);
static void set_predefined_command  (const char* command, int unused)
{
  char *ident;
  get_identifier(command,&ident);
  set_macros_file(ident);
}

static char* __spot_config_filename;
static void set_files_command  (const char* command, int unused)
{
  char* file;
  filename(command,&file);

  if (__spot_config_filename) free(__spot_config_filename);
  __spot_config_filename = malloc(strlen(file)+1);
  strcpy(__spot_config_filename,file);

  spot_config_filename=__spot_config_filename;
}

static void save_mem_command  (const char* command, int append)
{
  if (!database_opened(1))      return;
  int ai=test_already_inserted;
  test_already_inserted=0;
  database_clean();
  build_all_save();
  build_destroy();
  test_already_inserted=ai;
  mem_build=0;
}

static void build_mem_command  (const char* command, int append)
{
  if (!spot_config_filename)
    {
      printf("No file list loaded\n");
      return;
    }
  mem_build=1;
  build_init();
  build_all ();
}

void database_full_list(); // database.c

static void stat_command  (const char* command, int append)
{
  if (!database_opened(1))      return;  
  database_stat();
  database_full_list();
}


static void build_all_command  (const char* command, int append)
{
#if 0
  if (!database_opened(1)) return;
  build_mem_command(0,0);
  if (!append)     database_clean();
  save_mem_command(0,0);
  build_destroy();
  return;
#endif

  if (!spot_config_filename)
    {
      printf("No file list loaded\n");
      return;
    }
  int ai=test_already_inserted;
  test_already_inserted=0;
  build_init();
  if (!database_opened(1)) return;
  if (!append)
    {
      database_clean();
      building=1;
      build_all();
      build_all_save();
      build_destroy();
      building=0;
    }
  else
    {
      updating=1;
      update_all();
#ifndef DONT_SAVE_IN_UPDATE
      build_update_save();
#endif
      build_destroy();
      updating=0;

    }
  test_already_inserted=ai;
}

static void get_local_variable_dec_command (const char* command, int local_only)
{
  char* filename;
  int line,pos;
  name_line_pos(command,&filename,&line,&pos);
  get_local_var_dec  (filename , line , pos );
}
static void get_local_variable_use_command (const char* command, int local_only)
{
  char* filename;
  int line,pos;
  name_line_pos(command,&filename,&line,&pos);
  get_local_var_use  (filename , line , pos );
}


static void get_visible_command (const char* command, int local_only)
{
  char* filename;
  int line,pos;
  name_line_pos(command,&filename,&line,&pos);
  get_visible_at  (filename , line , pos, local_only);
}
static void get_called_by_function_at_command(const char* command, int local_only)
{
  char* filename;
  int line,pos;
  name_line_pos(command,&filename,&line,&pos);
  return get_called_by_function_at(filename, line, pos);
}

static void get_used_by_function_at_command(const char* command, int local_only)
{
  char* filename;
  int line,pos;
  name_line_pos(command,&filename,&line,&pos);
  return get_used_by_function_at(filename, line, pos);
}

static void get_visible_variable_command(const char* command, int local_only)
{
  char* filename;
  int line,pos;
  name_line_pos(command,&filename,&line,&pos);
  return get_visible_variable_at(filename, line, pos, local_only);
}
static void get_macro_definition_command(const char* command, int local_only)
{
  char* ident;
  get_identifier(command,&ident);

  if (mem_build)                 get_mem_macro_def(ident);
  else if (database_opened(1))    get_database_macro_def(ident);
  else printf("run build first\n");
}

static void get_function_declaration_command(const char* command, int local_only)
{
  char* ident;
  get_identifier(command,&ident);

  if (mem_build)                  get_mem_function_dec(ident);
  else if (database_opened(1))    get_database_function_dec(ident);
  else printf("run build first\n");
}
static void get_function_definition_command(const char* command, int local_only)
{
  char* ident;
  get_identifier(command,&ident);

  if (mem_build)                 get_mem_function_def(ident);
  else if (database_opened(1))    get_database_function_def(ident);
  else printf("run build first\n");
}
static void get_function_usage_command(const char* command, int local_only)
{
  char* ident;
  get_identifier(command,&ident);

  if (mem_build)               get_mem_function_use      (ident);
  else if (database_opened(1))  get_database_function_use (ident);
  else printf("run build first\n");
}
static void get_global_var_declaration_command(const char* command, int local_only)
{
  char* ident;
  get_identifier(command,&ident);

  if (mem_build)                  get_mem_variable_dec(ident);
  else if (database_opened(1))    get_database_variable_dec(ident);
  else printf("run build first\n");
}

static void get_global_var_usage_command(const char* command, int local_only)
{
  char* ident;
  get_identifier(command,&ident);

  if (mem_build)                get_mem_variable_use(ident);
  else if (database_opened(1))  get_database_variable_use(ident);
  else printf("run build first\n");
}
static void get_struct_dec_command(const char* command, int local_only)
{
  char* ident;
  get_identifier(command,&ident);

  if (mem_build)              get_mem_struct_dec(ident);
  else if (database_opened(1)) get_database_struct_dec(ident);
  else printf("run build first\n");
}

static void get_struct_def_command(const char* command, int local_only)
{
  char* ident;
  get_identifier(command,&ident);

  if (mem_build)               get_mem_struct_def(ident);
  else if (database_opened(1))  get_database_struct_def(ident);
  else printf("run build first\n");
}

static void get_struct_use_command(const char* command, int local_only)
{
  char* ident;
  get_identifier(command,&ident);

  if (mem_build)               get_mem_struct_use(ident);
  else if (database_opened(1))  get_database_struct_use(ident);
  else printf("run build first\n");
}

static void get_visible_function_command(const char* command, int local_only)
{
  char* filename;
  int line,pos;
  name_line_pos(command,&filename,&line,&pos);
  get_visible_function_at  (filename , line , pos, local_only);
}

static void get_visible_macro_command(const char* command, int local_only)
{
  char* filename;
  int line,pos;
  name_line_pos(command,&filename,&line,&pos);
  printf("get visible macro command\n");
  get_visible_preprocess_at  (filename , line , pos, local_only);
}



static void get_files_include_command(const char* command, int unused)
{
  char * file;
  filename(command,&file);
  printf("file %s is included by following files\n",file);

  if (mem_build)                 
    {
      if (!get_mem_include(file))
	// hledam castecnou shodu...
	{
	  regex_t re;
	  char* str;
	  int len = strlen(file);
	  char* regexp = malloc(len+2);
	  strcpy(regexp,file);
	  regexp[len]='$';
	  regexp[len+1]=0;
	  regcomp (&re, regexp, REG_EXTENDED);
	  mem_generator_next_string(1);
	  while ((str=mem_generator_next_string(0)))
	    {
	      if (! regexec (&re
			     , str
			     , 0
			     , 0
			     , 0) )
		get_mem_include(str);
	    }
	  free(regexp);
	}
      
    }
  else if (database_opened(1))   
    {
      if (!get_database_include(file)) 
	// hledam castecnou shodu...
	{
	  regex_t re;
	  char* str;
	  int len = strlen(file);
	  char* regexp = malloc(len+2);
	  strcpy(regexp,file);
	  regexp[len]='$';
	  regexp[len+1]=0;
	  regcomp (&re, regexp, REG_EXTENDED);
	  db_generator_next_string(1);
	  while ((str=db_generator_next_string(0)))
	    {
	      if (! regexec (&re
			     , str
			     , 0
			     , 0
			     , 0) )
		get_database_include(str);
	    }
	  free(regexp);
	}
    }
  else printf("run build first\n");
}
/* static char* act_db_file; */
static void set_database_command(const char* command, int create)
{
  if (create)    {      set_allow_write(1);      set_allow_create(1);    }
  char * file;
  filename(command,&file);

  if (get_db_file()) 
    database_end();

  set_db_file(file);

  database_init(get_db_file());
}

static void get_macro_use_command(const char* command, int unused)
{
  char* filename;
  char* macro;
  macro_filename(command,&macro,&filename);
  
  if (filename)      get_macro_use_file(macro,filename);
  else get_macro_use_all(macro);

}


static void get_typedef_use_command(const char* command, int unused)
{
  char* ident;
  get_identifier(command,&ident);
  if (mem_build)                get_mem_typedef_use(ident);
  else if (database_opened(1))   get_database_typedef_use(ident);  
  else printf("run build first\n");
}

static void list_strings_command(const char* command, int unused)
{
  if   (mem_build)               list_strings();
  else if (database_opened(1))   db_list_strings();  
  else printf("run build first\n");
}

static void get_typedef_declaration_command(const char* command, int unused)
{
  char* ident;
  get_identifier(command,&ident);
  if (mem_build)               get_mem_typedef_(ident);
  else if (database_opened(1))  get_database_typedef_(ident);  
  else printf("run build first\n");
}

static void get_struct_content_command(const char* command, int unused)
{
  //  char* filename=0;
  char* ident=0;
  //  macro_filename(command,&ident,&filename);
  get_identifier(command,&ident);
  get_structure_content_cmd ( ident );
};


#endif
