/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#ifndef CMD_FUNCTIONS_H
#define CMD_FUNCTIONS_H
#include "base/filelist.h"
extern int building;
extern int updating;
extern int deleting;
void spotsparse_file(const char* string);
static void  build_one  (const char* str);
static void  update_one (const char* str);
void config_source_compilation(const char* source
			       , const char* include_path
			       , const char* macro);
static void build_all()
{

  xalloc_context c; memset(&c,0,sizeof(c));
  xalloc_context* context = xalloc_get_context();
  xalloc_set_context(&c);


  int ai=test_already_inserted;
  test_already_inserted=0;
  remember_strings=1;
  init_config(get_spot_config());
  const char* str; int command;
  next_file(1,&command); /* provede reset */
  while ((str=next_file(0,&command)))
    {
      if (command != build_now) continue;
      const char* filename=get_filename(str);
      spotsparse_file(filename);
    }
  test_already_inserted=ai;

  xfree_all();
  xalloc_set_context(context);

}

static void update_all()
{

  xalloc_context c; memset(&c,0,sizeof(c)); c.name="update all context";
  xalloc_context* context = xalloc_get_context();
  xalloc_set_context(&c);

  remember_strings=0;

  init_config(get_spot_config());

  const char* str;

  {  int command;
    next_file(1,&command); /* provede reset */
    char** arg = 0;
    int arg_len=1;
    arg = malloc(sizeof(char*) * arg_len);
    *arg=0;
    
    while ((str=next_file(0,&command)))
      {
	if (command != update_now && command!=update_always ) continue;
	arg = realloc(arg,sizeof(char*) * (arg_len+1));
	arg[arg_len]=0;
	arg[arg_len-1]=malloc(strlen(str)+1);
	arg_len++;
	strcpy(arg[arg_len-2],str);

	const char* filename=get_filename(str);
	spotsparse_file(filename);
      }

/*     printf("goto delete\n"); */


    database_delete_file((const char**) arg);  /* vymaze vsechny soubory naraz */

/*     printf("deleted - return without building !!!\n"); */

    {  char** act=arg;       while (*act) { free(*act); act++; }     }

    free(arg);
  }

  xfree_all();
  xalloc_set_context(context);

}


static void update_one(const char* str)
{
  const char* arg[] = { str, 0 };
  database_delete_file(arg);
  build_one(str);
}

static void build_one(const char* str)
{
  config_source_compilation(str,0,0); /* pouziti globalnich ... */
  spotsparse_file(str);
}

// musim pouzit databazi
static void get_macro_use_all (const char* macro)
{
  if      (mem_build)            get_mem_macro_use(macro);
  else if (database_opened(1))   get_database_macro_use(macro);
}


static void process_filelist(int save)
{

  xalloc_context c; memset(&c,0,sizeof(c)); c.name="update all context";
  xalloc_context* context = xalloc_get_context();
  xalloc_set_context(&c);

  remember_strings=0;

  init_config(get_spot_config());

  const char* str;

  { int command;
    next_file(1,&command); /* provede reset */
    char** arg = 0;
    int arg_len=1;
    arg = malloc(sizeof(char*) * arg_len);
    *arg=0;
    
    while ((str=next_file(0,&command)))
      {
	if (save) 
	  if (command == update_now 
	      || command == update_always
	      || command == delete_now
	      || command == delete_now_recursive
	      //	    || command == delete_always
	      )
	    {
	      arg = realloc(arg,sizeof(char*) * (arg_len+1));
	      arg[arg_len]=0;
	      arg[arg_len-1]=malloc(strlen(str)+1);
	      arg_len++;
	      strcpy(arg[arg_len-2],str);
	    }

	if (save) 
	  if ( command == delete_now_recursive 
	       || command == update_now_recursive )
	    {
	      char** all_includes = get_all_includes(str);
	      if (all_includes)
		{
		  int len; for (len=0;all_includes[len];len++);
		  int prev_len=arg_len-1;
		  arg_len+=len;
		  arg = realloc(arg,sizeof(char*) * (arg_len+1));
		  int i;
		  for (i=0;all_includes[i];i++)
		    {
		      arg[prev_len+i]=all_includes[i];
		    }
		  arg[arg_len]=0;	    
		  free(all_includes);
		}
	    }
	if (command == update_now 
	    || command == update_always
	    || command == build_now
	    || command == update_now_recursive )	    
	  {
	    const char* filename=get_filename(str);
	    spotsparse_file(filename);
	  }
      }

#ifdef SHOW_RECURSIVE_DELETED_FILES
    int i; for(i=0;i<arg_len;i++)  printf("adding %s \n",arg[i]);
#endif

    if (save) 
      { 
	database_delete_file((const char**) arg);
	char** act=arg;
	while (*act)
	  { free(*act); act++; }     
      }

    free(arg);
  }

  xfree_all();
  xalloc_set_context(context);

}


#endif
