/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#ifndef CMD_READLINE_H
#define CMD_READLINE_H

char*  db_generator_next_string(int reset); /* database_strings.h */
char*  idents_generator (char *text, int state)
{
  static int len;
  const char *name;

	
  /* If this is a new word to complete, initialize now.  This includes
     saving the length of TEXT for efficiency, and initializing the index
     variable to 0. */
  if (!state)
    {
      len = strlen (text);
    }

  /* Return the next name which partially matches from the command list. */
  
  //while ( list_index < (sizeof (handlers) / sizeof (handlers[0])) && (name = handlers[list_index].command))
  if (!database_opened(0))
    {
      if ( mem_build) 
	while ((name = mem_generator_next_string(0)))
	  {
	    if (strncmp (name, text, len) == 0)
	      return (strdup(name));
	  }
    }
  else
    {
      while ((name = db_generator_next_string(0)))
	{
	  if (strncmp (name, text, len) == 0)
	    return (strdup(name));
	}
    }

  /* If no names matched, then return NULL. */
  return ((char *)NULL);
}

char * null_generator (char *text, int state)
{
  return ((char *)NULL);
}

char * command_generator (char *text, int state)
{
  static int list_index, len;
  const char *name;


	
  /* If this is a new word to complete, initialize now.  This includes
     saving the length of TEXT for efficiency, and initializing the index
     variable to 0. */
  if (!state)
    {
      list_index = 0;
      len = strlen (text);
    }

  /* Return the next name which partially matches from the command list. */
  
  //while ( list_index < (sizeof (handlers) / sizeof (handlers[0])) && (name = handlers[list_index].command))
  while ((name = handlers[list_index].command))
    {
      list_index++;
      if (strncmp (name, text, len) == 0)
	return (strdup(name));
    }

  /* If no names matched, then return NULL. */
  return ((char *)NULL);
}


extern void* completion_matches(char* text, char* (*generator) (char *, int ));
char ** cspot_completion (char *text, int start, int end)
{
  char **matches;

  matches = (char **)NULL;

  /* If this word is at the start of the line, then it is a command
     to complete.  Otherwise it is the name of a file in the current
     directory. */
  if (
      start == 0
      )
    matches = (char**) completion_matches (text, command_generator);
  else 
    {
      if (strlen(rl_line_buffer)>=strlen(HELP_CMD) 
	  && !strncmp (rl_line_buffer, HELP_CMD, strlen(HELP_CMD)) )  
	{
	  matches = (char**) completion_matches (text, command_generator);
	  return matches;
	}
      int b = 0, f = 0, i = 0;
      for(;i<(sizeof (handlers) / sizeof (handlers[0]));i++)
	{
	  if (handlers[i].command 
	      && strlen(handlers[i].command) == start-1 
	      && !strncmp(handlers[i].command,rl_line_buffer,strlen(handlers[i].command))
	      )
	      {
		if (handlers[i].want_ident ) {
		  b=1;
		  break;
		}
		else if (handlers[i].want_file ) {
		  f=1;
		  break;
		}
	      }
	}
      if (b ) /* chceme doplnovani z databaze */
	{
	  if (!database_opened(0))
	    {
	      if ( mem_build) 
		mem_generator_next_string(1); /* do reset */
	    }
	  else 
	    {
	      db_generator_next_string(1); /* do reset */
	    }
	  matches = (char**) completion_matches (text, idents_generator);
	}
      else if (!f) 
	return (char**) completion_matches(text,null_generator);
    }
  return (matches);
}

void init_readline()
{
  rl_attempted_completion_function = (CPPFunction *)cspot_completion;
}

#endif
