/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#ifndef PAGE_SIZE
#error PAGE_SIZE not defined 
#endif

#ifndef SPOT
#error SPOT not defined, sparse would not be compiled properly
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <readline/readline.h>
#include <readline/history.h>

#include "database/file.h"
#include "database/fagin.h"
#include "database/database.h"
#include "database/memsave.h"

#include "interface/build.h"

#include "base/options.h"

#include "base/config.h"
#include "base/xalloc.h"
#include "base/cmd.h"
#include "base/macros.h"


/* ze sparse-interface */
extern int    pre_buffer_allocated;
extern char  *pre_buffer;
extern void   init_interface();

/* sparse-build */
extern void init_functions();

/* add-fce */
extern void add_init();

void init(int argc, char **argv)
{
  //  verbose=2;
  init_interface();
  init_functions();
  add_init();

  sparse_build_functions();

  use_args(argc,argv);
}

extern void init_readline(); /* cmd.c */
int main(int argc, char **argv)
{
#ifdef SHOW_ARGS
    {int i=0; for (i=0;i<argc;i++) printf("'%s' ",*(argv+i)); printf("\n");}
#endif
  argv++;
  init(argc,argv);
  init_readline();
  char *command;
  while ( (command=readline("command: ")))
    {
      if (!run_command(command))
	{
	  printf("not recognised command %s\n",command);
	  free(command);
	}
      else
	add_history(command);
    }
  printf("end of input\n");
  database_end();
  exit(0);
  return 0;
}
