/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

/* 
   chci  : 
       v enviroment mit promennou rikajici nazev souboru
       k tomuto souboru pripojovat radky
              dana radka rika ktery soubor zaradit do databaze a s jakou include path a jakymi makry soubor kompilovat
*/

/*
  prijimam stejne ospny jako gcc
  udelam nasledujici:
        do souboru jehoz nazev je v promenne prostredi pridam jmeno kompilovaneho souboru
	vytvorim pro kompilovany soubor i soubory $i.m & $i.i ktere obsahuji makra definovana v parametrech gcc & include cesty v parametrech gcc
 */
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <unistd.h>

#include "macros.h"
#if 0
void print_int(int i) {
  int mask=1<<31;
  int num;

  for (num=0; num<32;num++,i<<=1)
    putchar("01"[!!(i&mask)]);
}

int test() {
  print_int(   (1<<31)       );printf("\n");
  print_int(  ((1<<31)>>15)  );printf("\n");
  print_int( ~((1<<31)>>15)  );printf("\n");
  print_int( (~((1<<31)>>15)) & 15 );printf("\n");
  exit(0);
}
#endif








static const char* config_file = 0; // = DEFAULT_CONFIG;
static const char* config_compiler;
static const char* config_dir;
static const char* config_filelist;

//FILE* open_file(const char* file, const char* flags);

FILE* open_filelist(const char* file);

void record(int argc
	    , char** argv
	    , const char* filename
	    , const char* mcr
	    , const char* inc
	    , const char* files);

static char* read_line (FILE* f, char* buffer)
{
 int pos=0;
 char c;
 while((c=fgetc(f)))
   {
     if (c=='\n')
       {
	 buffer[pos]=0;
	 return buffer;
       }
     else if (c==-1)
       {
	 buffer[pos]=0;
	 return buffer;
       }
     else
       {
	 buffer[pos]=c;
	 buffer[pos+1]=0;
       }
     pos++;
     if(pos==MAX_LEN)
       {
	 fprintf(stderr,"buffer too short\n");
	 exit(1);
       }
   }
 return 0;
}


#define OPTION(buffer,opt,dst)           \
  {                                      \
    int l = strlen(buffer);              \
    int m = strlen(opt);                 \
    if (l>m && !memcmp(buffer,opt,m))    \
      {                                  \
	char* t = buffer+m;              \
	while(*t=='\t' || *t==' ') t++;  \
	if (*t=='=') t++;                \
	while(*t=='\t' || *t==' ') t++;  \
	strcpy(dst,t);                   \
      }                                  \
  }

void config_init(int argc, char** argv)
{
  { int i; 
  for (i=0;i<argc;i++)
    {
      if (!strcmp(argv[i],"-configfile") ){
	  if (i!=argc-1) config_file=argv[i+1];
	  else {fprintf(stderr,"-configfile requires parametr\n");}}
      if (!strcmp(argv[i],"-compiler")) {
	if (i!=argc-1) config_compiler = argv[i+1];
	else {fprintf(stderr,"-compiler requires parametr\n");}}
      if (!strcmp(argv[i],"-directory")) {
	if (i!=argc-1) config_dir = argv[i+1];
	else {fprintf(stderr,"-directory requires parametr\n");}}
      if (!strcmp(argv[i],"-filelist")) {
	if (i!=argc-1) config_filelist=argv[i+1];
	else {fprintf(stderr,"-filelist requires parametr\n");}}
    }}
  if (config_file)
    {
      FILE* f = fopen(config_file,"r");
      if (!f)  goto def;
      static char comp[MAX_LEN];
      static char dir [MAX_LEN];
      static char fl  [MAX_LEN];
      
      char buffer[MAX_LEN];
      while (!feof(f))
	{
	  read_line(f,buffer);
	  OPTION(buffer, "COMPILER" , comp);
	  OPTION(buffer, "DIRECTORY", dir );
	  OPTION(buffer, "FILE_LIST", fl  );
	}
      if (!config_compiler) config_compiler = comp;
      if (!config_dir)      config_dir      = dir;
      if (!config_filelist) config_filelist = fl;
      fclose(f);
    }
  else {
    if (!config_compiler) 
      {
	config_compiler = DEFAULT_COMPILER;
	fprintf(stderr, "using default configuration - compiler=%s\n"
		, config_compiler);
	
      }
    if (!config_dir) 
      {
	config_dir      = DEFAULT_OUTPUT_DIRECTORY;
	fprintf(stderr, "using default configuration - directory=%s\n"
		, config_dir);
      }
    if (!config_filelist)
      {
	config_filelist = DEFAULT_FILELIST;
	fprintf(stderr, "using default configuration - filelist=%s\n"
		, config_filelist);
      }
  }
  
def:
  return;
}
#undef OPTION

const char* config_get_compiler()
{
  return config_compiler;
}

const char* config_get_dir(char** argv)
{
  return config_dir;
}

const char* config_get_filelist()
{
  return config_filelist;
}


static FILE* open_file(const char* file, const char* flags)
{
  FILE* f;
  f = fopen(file,flags);
  if (!f)
    {
      int i;
      int l=strlen(file);
      char* s = malloc(l+1);
      strcpy(s,file);
      for (i=l;i>0;i--)
	{
	  if (s[i]=='/')
	    {
	      s[i]=0;
	      if (!mkdir(s,S_IRWXU))
		goto ok;
	    }
	}
    ko:
      fprintf(stderr, "couldn't create directory %s \n",s);
      return 0;
    ok:
      /*       printf("DIRECTORY CREATED\n"); */
      for (;i<l;i++)
	{
	  if (s[i]==0)
	    {
	      s[i]='/';
	      if ((f = fopen(file,flags))) return f;
	      if (  mkdir(s,S_IRWXU) /* mkdir(s,S_IRUSR|S_IWUSR) */  )
		goto ko;
	    }
	}     
      f = fopen(file,flags);
    }
  return f;
}

FILE* open_filelist(const char* file)
{
  FILE* spot = open_file(file,"a");
  if (!spot) exit(1);
  return spot;
}

int file_exists(const char* filename)
{
  int exists=0;
  int fd = open(filename,O_RDONLY);
  if (fd<0) goto end; /* soubor neexistuje - pouzito zrejme pro generovani globalnich .i a .i*/
  struct stat s;
  if (fstat(fd,&s)) goto end; /* opet soubor nelze spravne otevrit */
  exists=1;
 end:
  close(fd);
  return exists;
}

void edit_args(int argc,char** argv,char* prg)
{
  *argv=prg;  // *argv= (char*) malloc(strlen(prg)+1); strcpy(*argv,prg);
  
  int i; for (i=0;i<argc && argv[i];i++)
    {
      if (
	  (!strcmp(argv[i],"-configfile") )
	  || (!strcmp(argv[i],"-compiler"))
	  || (!strcmp(argv[i],"-directory"))
	  || (!strcmp(argv[i],"-filelist") ))
	{
	  int j;
	  for(j=i;j<argc-2;j++)
	    {
	      argv[j]=argv[j+2];
	      argv[j+2]=0;
	    }
	  i--;
	  argc-=2;
	}
    }
#if 0
  printf("\n--------\n");
  printf("argumenty argc=%d\n",argc);
  for (i=0;i<argc;i++)
    printf("%s ",argv[i]);
  printf("\n--------\n");
#endif
}


int main(int argc, char** argv)
{
  /* 
     musi byt uvedena uplna cesta: predpokladam ze bude pouzito takto:
     jmeno spustitelneho programu = gcc
     zmenena jen cesta
       tedy by doslo k zacykleni a stale spousteni , kdyby nebyla uplna cesta
  */
  config_init(argc,argv);

  const char* prg         = config_get_compiler();
  const char* cspot_dir   = config_get_dir(argv);
  const char* cspot_files = config_get_filelist();

#if 0
  printf("prg %s\n",prg);
  printf("cspot_dir %s\n",cspot_dir);
  printf("cspot_files %s\n",cspot_files);
#endif
  int cspot_dir_len   = strlen(cspot_dir);
  int cspot_files_len = strlen(cspot_files);

#if 0  // i want to find the name of file to compile
  const char* filename = argv[argc-1];
  { 
    int i = strlen(filename);
    if (i<=strlen(".c") || strcmp(filename+i-strlen(".c"),".c")) 
      {
	printf("not a c source file? %s\n",filename);
	goto compile;
      }
  }
#else
  const char* filename=0;
  {
    int i;
    for(i=0;i<argc;i++)
      {
	const char* str = argv[i];
	int len = strlen(str);
	if (!strcmp(str+len-2,".c")) // needs fixing
	{
	  filename = str;
	  break;
	}
      }
    if(!filename) goto compile; // nothing to do with this file
  }
#endif

  {  
    char* files = malloc(cspot_dir_len+1+cspot_files_len+1);
    strcpy(files,cspot_dir);
    files[cspot_dir_len]='/';
    strcpy(files+cspot_dir_len+1,cspot_files);

    int len=strlen(filename);
    char * inc = malloc(cspot_dir_len+1+len+3); strcpy(inc,cspot_dir); inc[cspot_dir_len]='/';       strcpy(cspot_dir_len+1+inc,filename); strcpy(cspot_dir_len+1+inc+len , ".i");
    char * mcr = malloc(cspot_dir_len+1+len+3); strcpy(mcr,cspot_dir); mcr[cspot_dir_len]='/';       strcpy(cspot_dir_len+1+mcr,filename); strcpy(cspot_dir_len+1+mcr+len, ".m");
  
    record(argc,argv,filename,mcr,inc,files);

    free(files);
    free(mcr);
    free(inc);
  }

  if (!file_exists(filename)) return 0;

 compile:
  if (prg)
    {
      edit_args(argc,argv,(char*)prg);

	execvp(*argv,argv);
    }
  return 0;
}

#include "base/filelist.h"
void do_stuff_record(const char* files
		, const char* filename
		, const char* inc
		, const char* mcr)
{
#if 1
 file_record rec;
 if (strlen(filename)<MAX_LEN) strcpy(rec.filename,filename);
 else { fprintf(stderr,"source filename too long\n"); exit(1); }
 if (strlen(inc)<MAX_LEN) strcpy(rec.include,inc);
 else { fprintf(stderr,"include filename too long\n"); exit(1); }
 if (strlen(mcr)<MAX_LEN) strcpy(rec.macro,mcr);
 else { fprintf(stderr,"macro filename too long\n"); exit(1); }

 rec.todo=not_set;
 add_record(files,rec);

#else
  FILE* spot = open_file(files,"a");
  if (!spot) { exit(1); }

  fputs(filename,spot);
  fputs(":",spot);
  fputs(inc,spot); 
  fputs(":",spot);
  fputs(mcr,spot);
  fputs("\n",spot);

  fclose(spot);
#endif
}

void record(int argc
	    , char** argv
	    , const char* filename
	    , const char* mcr
	    , const char* inc
	    , const char* files)
{
  FILE* include  = open_file( inc , "w");
  FILE* macro    = open_file( mcr , "w");

#ifdef MY_WARNS
#warning fixit
#endif
  /*
    co kdyz se zmenili pouze cesty k includum & makra 
    ale buildovany soubor zustava---potrebuju rebuild
   */
  if(!include || !macro) 
    {
      fprintf(stderr,"not adding to db file %s\n",filename);
      return;
    }
  int i;
  for (i=0;i<argc;i++)
    {
      if ( argv[i][0]=='-' && argv[i][1]=='I' )
	{
	  fputs(argv[i]+2,include);	  fputs("\n",include);
	}
      else if (  argv[i][0]=='-' && argv[i][1]=='D'  )
	{
	  fputs("#define ",macro);
	  int o; 
	  int j=strlen(argv[i]);
	  for(o=2;o<j;o++) 
	    if (argv[i][o] == '=') 
	      { 
		argv[i][o] =' '; 
		fputs(argv[i]+2 , macro);
		argv[i][o] ='='; 
		goto end_for;
	      } 
	  fputs(argv[i]+2 , macro);
	end_for:
	  fputs("\n", macro);
	}
    }
  fputs("\n", macro);

  fclose(include);
  fclose(macro);

  do_stuff_record(files,filename,inc,mcr);
}
