/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#ifndef FILELIST_H
#define FILELIST_H
#include "base/macros.h"
enum TODO {
  not_set                 = '?',
  noaction_now            = '%',
  build_now               = '+',
  update_now              = 'u',
  update_always           = '*',
  update_now_recursive    = 'U',
  ignore_always           = '#',
  delete_now              = '-',
  delete_now_recursive    = '_',
};

typedef struct {
  char filename[MAX_LEN];
  char macro   [MAX_LEN];
  char include [MAX_LEN];
  enum TODO todo;
} file_record;

void add_record(const char* file, file_record rec);
int get_record(const char* file, file_record* rec, int start_pos);
int unset_record(const char* file, int start_pos);

#endif
