/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#include <string.h>
#include "xalloc.h"
#include "macros.h"

#define LAZY_ALLOC

static char default_buffer[MAX_LEN];
const char* get_filename(const char* f)
{
/*   printf("called filename=%s\n",f); */
  //  return f;
  int ii=0; for (ii=0;ii<MAX_LEN;ii++) default_buffer[ii]=0;
  if ( *f=='.' && *(f+1)=='/' ) f+=2; 
  int j=strlen(f);
  if (j>MAX_LEN) return 0;
#ifdef LAZY_ALLOC
  char* a = default_buffer;
  //  memset(default_buffer,0,MAX_LEN);
  a[j-1]=a[j]=0;
#else 
  // pozor na memleak --  vsichni musi dusledne dealokovat
  // jsem ale v kontextu toho kdo me volal, takze by me jeho xfree_all mel dealokovat
  char* a =xalloc(j+1);
#endif
  int ai=j-1;
  
  int back=0, no_copy=0;
  int i;
  int changed=0;
  for (i=j-1;i>=0;i--)
    {
      if (*(f+i  )=='/')
	{
	  if (i>=3)
	      if (!memcmp(f+i-2,"/./",3))
		{
		  i-=1;
		  changed=1;
		  continue;
		}
	  if (i>=4)
	    if (!memcmp(f+i-3,"/../",4))
		{
		  back++;
		  i-=2;
		  changed=1;
		  continue;
		}
	  if (back>0)
	    {
	      changed=1;
	      no_copy=1;
	      back--;
	    }
	  else
	    {
	      no_copy=0;
	      *(a+ai)=*(f+i);
	      ai--;
	    }
	}
      else 
	{
	  if (!no_copy)
	    {
	      changed=1;
	      *(a+ai)=*(f+i);
	      ai--;
	    }
	}
    }
#ifdef LAZY_ALLOC
  if (changed)
    {
      char *r = xalloc(strlen(a+ai+1)+1);
      strcpy(r,a+ai+1);
/*       printf("returned filename=%s\n",r); */
      return r;  // pamet bude uvolnena v xfree_all
    }
  else 
    {
/*       printf("returned filename=%s\n",f);       */
      return f;
    }
#else
  return a+ai+1;
#endif
}
