/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#ifndef XALLOC_H
#define XALLOC_H

#if 0

#define xalloc(s) malloc(s)
#define xfree(s) free(s)
#define xrealloc(a,b) realloc(a,b)
#define xfree_all() /**/
#define xstat() /**/
#else

#define xalloc(s) myalloc(s)
#define xfree(s) myfree(s)
#define xfree_all() myfree_all()
#define xrealloc(a,b) myrealloc(a,b)
#define xstat mystat

#endif

void* myalloc(int);
void  myfree(void*);
void  myfree_all();
void* myrealloc(void*,int);
void mystat();

struct head_struct;

typedef struct {
  struct head_struct* first;
  struct head_struct* last;
  int size;
  int allocated;
  const char* name;
} xalloc_context;

void xalloc_set_context(xalloc_context*);
xalloc_context* xalloc_get_context();
#endif
