/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "database.h"
#include "file.h"
#include "fagin.h"
#include "memsave.h"

#include "base/xalloc.h"
#include "base/config.h"
#include "base/macros.h"

#include "templates/hash_algo.c"


#include "templates/string.h"
#include "templates/struct2.h"
#include "templates/struct4.h"
#include "templates/struct7.h"

int chain_find(hash_table* table
	       , const void* key
	       , int (*found_item_callback) (uint32_t adr))
{
  return 0;
}

void database_init(const char* name)
{

#define SET_TABLE(typ,tab) DO_SET_TABLE_TYP(typ,tab)
#define DO_SET_TABLE_TYP(x,tab) DODO_SAVE_TABLE_TYP(x,tab)
#define DODO_SAVE_TABLE_TYP(x,tab) set_table_ ## x (& tab) /* nastavi funkce */

/*   printf("database init\n"); */
/*   printf("calls open file\n"); */
  file=open_file(name);

/*   printf("\n\nrunning macro\n"); */
#define table(tab,unused_poloha, typ)   \
  SET_TABLE(typ, tab);   \
  read_table (& tab , &file, &file.head. tab ## _table_address__be);
  /* in read table there will be a folder allocated */
  TABLES
#undef table
    identifier.allow_chain=0;
  }

void database_clean()
{
/*   printf("database clean called !!!!!!!\n"); */
  const char* filename=file.filename;
  file_clean(&file);
  database_init(filename);
}
int database_opened(int i)
{
  if (file.fd) 
    {
      return 1;
    }
  else 
    {
      if (i)
	fprintf(stderr,"no database opened\n");
      return 0;
    }
}

void database_end()
{
#ifdef MY_WARNS
#warning savovat podle toho co se predtim delo? ... myslim ze dulezite pouze pro bm, db-rw, (!sm), bye
#endif
#ifdef SAVE_ON_CLOSE
  if (database_opened(0))    
    build_all_save();
#endif
  close_file(&file);
}

#ifdef CHAIN_LENGTH
extern uint32_t next_free_page(file_t* file,uint32_t adr); /* file.c */
static int free_space_counter()
{
  uint32_t pg_adr=read_int(&file,FREE_PAGE);
  int length=0;
  do {
    length++;	  
  } while (pg_adr && (pg_adr=next_free_page(&file,pg_adr)));
  return length;
}
void database_stat()
{
  printf("free pages: %d\n", free_space_counter());
#define S(x) SS(x)
#define SS(x) # x
#define table(x,y,z) printf("lengths in database %s\n", S(x) );\
                     chain_length_counter (& x);
TABLES
#undef table
}
#endif

static  const char** ret = 0;
static  int ret_i=0;

static int found_item_callback_get_database_struct_def_files (uint32_t adr)
{
  if (!ret)
    {
      ret = xalloc(sizeof(void*));
      *ret=0;
    }
  __item_struct4 item;
  get_item_struct4(&file,adr,&item) ;
  ret_i++;
  ret=xrealloc(ret,(ret_i+1)*sizeof(void*));
  *(ret+ret_i)=0;
  *(ret+ret_i-1) = read_string(&file,(item.filename_adr));
  return 0;
}

static const char** return_get_database_struct_def_files()
{
  return ret;
}

static void clean_get_database_struct_def_files()
{
  if (ret) xfree(ret);
  ret=0;
}
/*
  vrati soubory ktere tuto strukturu definuji
  alokuje v aktualnim kontextu, za uvolneni vracene pameti je zodpovedna volajici funkce
 */
const char** get_database_struct_def_files (const char* ident)
{
  /* melo by byt cisteno odjinud !!! */
  clean_get_database_struct_def_files();
  uint32_t id=db_find_string(/* & identifier , */ident);
  if (!id) { return 0;}
  uint32_t i = find(& struct_def
		     , &id
		     , found_item_callback_get_database_struct_def_files
		     , 0 );
  if (!i )
    return 0;
  else
    return return_get_database_struct_def_files();
}




/*
  nadefinovani funkci 
  uint32_t db_find_string( const char* string);
  uint32_t db_get_string ( const char* string);
  uint32_t db_add_string ( const char* string);
*/

#include "database/strings.h"


/////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////
/*
  nadefinovani funkci save_database_ ## x
                      test_saved_database_ ## x
                      get_database_ ## x
*/
#include "database/fn_template.h" /* sablona definujici makra save_ saved_ get_ */
#define do_struct4(x) \
       save_struct4(x)\
       saved_struct4(x)\
       has_struct4(x)\
       get_struct4(x)\
       save_database_chain4(x)

#define do_struct7(x) \
       save_struct7(x)\
       has_struct7(x)\
       saved_struct7(x)\
       get_struct7(x)\
       save_database_chain7(x)

#define do_struct2(x) \
       save_struct2(x)\
       saved_struct2(x)\
       has_struct2(x)\
       get_struct2(x)\
       save_database_chain2(x)

#define do_string(x)


#define table(tab, unused, typ) DO_STRUCT(tab,typ)
#define DO_STRUCT(tab,typ) DODO_STRUCT(tab,typ)
#define DODO_STRUCT(tab,typ) do_ ## typ (tab)

TABLES

#undef save_database_chain4
#undef do_struct4
#undef save_struct4
#undef saved_struct4
#undef get_struct4
#undef has_struct4

#undef do_struct7
#undef has_struct7
#undef save_struct7
#undef saved_struct7
#undef get_struct7
#undef save_database_chain7

#undef do_struct2
#undef has_struct2
#undef save_struct2
#undef saved_struct2
#undef get_struct2
#undef save_database_chain2

#undef table
#undef DO_STRUCT
#undef DODO_STRUCT
/////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////












/*
  Vypise nepuzite globalni promenne
  jak:
      ziska seznam vsech deklarovanych promennych a pro kazdou z nich hleda kde byla pouzita
      pokud nalezne pak vyradi ze seznamu
      vypise zbytek nevyrazene prvky seznamu

  pozor:
      nefunguje napr pro builtin_scope
      stejne tak nefunguje 
 */


void database_find_unused_variable_list_action(uint32_t adr)
{
  __item_struct4 item_dec;
  get_item_struct4(&file,adr,&item_dec);
  
  uint32_t i = find (& variable_use, &item_dec.identifier_adr,0,0);
  if (!i)
    {
      printf("unused variable ");
      WRITE4(read_string(&file,(item_dec.identifier_adr)),
	     read_string(&file,(item_dec.filename_adr)),
	     (item_dec.line),
	     (item_dec.pos));    
    }
  return;
}

void database_find_unused_variable()
{
  list(&variable_dec,database_find_unused_variable_list_action);
}




void database_find_unused_function_def_list_action(uint32_t adr)
{
  __item_struct4 item_dec;
  get_item_struct4(&file,adr,&item_dec);
  
  uint32_t i = find(& function_use, &item_dec.identifier_adr,0,0);
  if (!i )
    {
      printf("unused function ");
      WRITE4(read_string(&file,(item_dec.identifier_adr)),
	     read_string(&file,(item_dec.filename_adr)),
	     (item_dec.line),
	     (item_dec.pos));    
    }
}

void database_find_unused_function_def()
{
  list(&function_def,database_find_unused_function_def_list_action);
}

































///////////////////////////////////////////////////
///////////////////////////////////////////////////
///////////////////////////////////////////////////
/* 
   vlozi do databaze informaci file->identifikator
 */
void db_add_file_ident(uint32_t file_adr, uint32_t ident_adr)
{
  __item_struct2 item;
  item.key_adr=file_adr;
  item.data=ident_adr;
  item.key=&item.key_adr;
  item.is_chain=0;
  insert(&files,&item);
}

static int found_db_file_add_callback_compar (int set                  
					   , __item_struct2 item )  
{                                                                     
  static int has;                                                     
  static __item_struct2  ITEM_NAME;                                   
  if ( set==1 )                                                       
    {                                                                 
      ITEM_NAME=item;  has=0; return 0;                               
    }                                                                 
  else if ( set==2 )                                                  
    {                                                                 
      return has;                                                     
    }                                                                 
  else                                                                
    {                                                                 
      if (              
	     ITEM_NAME . key_adr       == item.key_adr
	  && ITEM_NAME . data          == item.data
	  )                                                           
	{ has=1; return 1; }                                          
      else                                                            
	return 0;                                                     
    }                                                                 
  return 0;                                                           
}                                                                     
static int found_db_file_add_callback (uint32_t adr)                   
{                                                                     
  __item_struct2 item;                                                
  get_item_struct2(&file,adr,&item) ;                                 
  if (found_db_file_add_callback_compar (0,item))                      
       return 1;                                                      
  else return 0;                                                      
}           
int db_has_file_ident(uint32_t file_adr, uint32_t ident_adr)
{                                                           
  __item_struct2 item;    

  item.key_adr=file_adr;
  item.data=ident_adr;
  item.key=&item.key_adr;
                                  
  found_db_file_add_callback_compar (1,item);                
  find(& files,item .key,found_db_file_add_callback,0 );           
  return   found_db_file_add_callback_compar (2,item);       
}

static __item_struct2 **database_delete_file_filenames_item=0;
static int  database_delete_file_items_size=0;
static __item_struct2 **database_delete_file_filenames_item_chain=0;
static int  database_delete_file_items_size_chain=0;
static xalloc_context database_delete_file_context; 
static void database_delete_file_reset()
{
  xalloc_context* t = xalloc_get_context(); 
  xalloc_set_context(&database_delete_file_context);
  xfree_all();
  xalloc_set_context(t);

  database_delete_file_filenames_item=0;
  database_delete_file_items_size=0;
  database_delete_file_filenames_item_chain=0;
  database_delete_file_items_size_chain=0;
  memset(&database_delete_file_context,0,sizeof(xalloc_context));
}

static int database_delete_file_callback_chain(uint32_t adr)
{
  xalloc_context* t = xalloc_get_context(); 
  xalloc_set_context(&database_delete_file_context);
  
  __item_struct2* alloc = (__item_struct2*) xalloc(sizeof(__item_struct2));

  database_delete_file_filenames_item_chain
    = xrealloc(database_delete_file_filenames_item_chain
	      , (database_delete_file_items_size+2)*sizeof(void*));

  get_item_struct2(&file, adr, alloc) ;

  *(database_delete_file_filenames_item_chain
    + database_delete_file_items_size_chain) = alloc;
  *(database_delete_file_filenames_item_chain
    + database_delete_file_items_size_chain+1) = 0;

  database_delete_file_items_size_chain++;

  xalloc_set_context(t);
  return 0;
}

static int database_delete_file_callback(uint32_t adr)
{
  xalloc_context* t = xalloc_get_context(); 
  xalloc_set_context(&database_delete_file_context);
  
  __item_struct2* alloc = (__item_struct2*) xalloc(sizeof(__item_struct2));

  database_delete_file_filenames_item
    = xrealloc(database_delete_file_filenames_item
	      , (database_delete_file_items_size+2)*sizeof(void*));

  get_item_struct2(&file, adr, alloc) ;

  *(database_delete_file_filenames_item
    + database_delete_file_items_size) = alloc;
  *(database_delete_file_filenames_item
    + database_delete_file_items_size+1) = 0;

  database_delete_file_items_size++;

  xalloc_set_context(t);
  return 0;
}

void database_delete_file(const char** filenames) 
     /* 0 terminated list of filenames*/
{
  database_delete_file_reset();

  int i;
  const char **f;
  int count; /* pocet prvku seznamu filename */

  for (count=0,f=filenames;*f;f++,count++);


#ifdef MY_WARNINGS
#warning function not checked !!
#endif


  for (i=0,f=filenames;*f;f++,i++)
    {
      /* zjisti adresu identifikatoru souboru a ulozi do id */
      uint32_t id     = db_find_string(/* & identifier , */ *f);
      /* zjisti jake identifikatory jsou timto souborem pouzivany */
      /* uint32_t result = */
      find(&files
	   , &id
	   , database_delete_file_callback
	   , database_delete_file_callback_chain);
      //  if (!result) return;
      
    }
  if (!database_delete_file_filenames_item 
      && !database_delete_file_filenames_item_chain) return;

  /*   printf("doing delete\n"); */

  /* 
     poznamka: delete_all_* dela sice zasahy do databaze
     , ale v get_item_numbers jsou jen adresy a nikoli odkazy do databaze
     -> toto nevadi a nedojde k nekonzistenci pri uprave databaze
   */

#define do_struct4(x) \
  if (database_delete_file_filenames_item) delete_all_FILE_IDENT(& x , database_delete_file_filenames_item); \
  if (database_delete_file_filenames_item_chain) delete_all_FILE_IDENT_chain(& x , database_delete_file_filenames_item_chain); 
#define do_struct7(x) \
  if (database_delete_file_filenames_item) delete_all_FILE_IDENT(& x , database_delete_file_filenames_item); \
  if (database_delete_file_filenames_item_chain) delete_all_FILE_IDENT_chain(& x , database_delete_file_filenames_item_chain); 
#define do_struct2(x)
#define do_string(x)

#define table(tab, unused, typ) DO_STRUCT(tab,typ)
#define DO_STRUCT(tab,typ) DODO_STRUCT(tab,typ)
#define DODO_STRUCT(tab,typ) do_ ## typ (tab)

TABLES

#undef do_struct4
#undef do_struct7
#undef save_struct4
#undef saved_struct4
#undef get_struct4
#undef save_struct7
#undef saved_struct7
#undef get_struct7
#undef save_struct2
#undef saved_struct2
#undef get_struct2
#undef table
#undef DO_STRUCT
#undef DODO_STRUCT

  
  for (f=filenames; *f; f++ )
    {
      uint32_t id = db_find_string(/* & identifier , */ *f);
      delete(&files, &id);
    }
 database_delete_file_reset();
}

///////////////////////////////////////////////////
///////////////////////////////////////////////////
///////////////////////////////////////////////////
///////////////////////////////////////////////////
///////////////////////////////////////////////////
///////////////////////////////////////////////////







void database_find_unused_include_list(uint32_t adr)
{
#ifdef MY_WARNINGS
#warning udelat list cele databaze a pokud nic 
#endif
}

void database_find_unused_include()
{
  list(&include,database_find_unused_include_list);
}








static int database_full_list4_action_check_has;
static uint32_t database_full_list4_action_check_identifier;
static uint32_t database_full_list4_action_check_filename;
int database_full_list4_action_check(uint32_t adr)
{
  __item_struct2 item;
  get_item_struct2(&file,adr,&item);
  if (
      item.filename_adr==database_full_list4_action_check_filename
      && item.identifier_adr==database_full_list4_action_check_identifier
      )
    {
      database_full_list4_action_check_has=1;
      return 1;
    }
  return 0;
}

void database_full_list4_action(uint32_t adr)
{
  __item_struct4 item_dec;
  get_item_struct4(&file,adr,&item_dec);

  database_full_list4_action_check_identifier = item_dec.identifier_adr;
  database_full_list4_action_check_filename   = item_dec.filename_adr;

  find (&files
	, &database_full_list4_action_check_filename
	, database_full_list4_action_check
	, 0);
  if (database_full_list4_action_check_has)
    printf("+++ ");
  else 
    printf("--- ");
  database_full_list4_action_check_has=0;


  WRITE4(read_string(&file,(item_dec.identifier_adr)),
	 read_string(&file,(item_dec.filename_adr)),
	 (item_dec.line),
	 (item_dec.pos));
  return;
}

void database_full_list()
{
  list(&macro_use,database_full_list4_action);
}




static char ** found_item_callback_get_database_included_files_list;
static int found_item_callback_get_database_included_files_list_size;
static int found_item_callback_get_database_included_files (uint32_t adr)
{
  __item_struct2 item;
  get_item_struct2(&file,adr,&item) ;
  found_item_callback_get_database_included_files_list_size++;

  const char* aa = read_string(&file,(item.identifier_adr));
  char* a = malloc(strlen(aa)+1);
  strcpy(a,aa);

  found_item_callback_get_database_included_files_list
    =realloc(found_item_callback_get_database_included_files_list
	     , sizeof(char*) * (1+found_item_callback_get_database_included_files_list_size));
  found_item_callback_get_database_included_files_list[found_item_callback_get_database_included_files_list_size] = 0;
  found_item_callback_get_database_included_files_list[found_item_callback_get_database_included_files_list_size-1] = a;


#ifdef SHOW_IS_INCLUDED
  printf("%s is included\n", (char*)read_string(&file,(item.identifier_adr)));
#endif

  return 0;
}


char** get_all_includes(const char* filename)
{
  found_item_callback_get_database_included_files_list = 0;
  found_item_callback_get_database_included_files_list_size = 0;

  uint32_t id=db_find_string(filename);
  if (!id) { 
    fprintf(stderr,"string '%s' not in db but it should be (if you are really updating) !!! \n",filename); 
    return 0; 
  }
  find(& included
       , &id
       , found_item_callback_get_database_included_files
       , 0);

  return found_item_callback_get_database_included_files_list;
}
