/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#ifndef DATABASE_H
#define DATABASE_H
#include "file.h"

file_t file;

#define table(x,unused1,unused2) hash_table x
TABLES
#undef table


uint32_t db_get_string (/* hash_table* table,  */const char* string);
uint32_t db_add_string (/* hash_table* file,  */const char* string);
uint32_t db_find_string(/* hash_table* table,  */const char* string);

void database_clean();
void database_init();
void database_end();
int  database_opened(int);
#ifdef CHAIN_LENGTH
void database_stat();
#endif

void database_delete_file          ( const char** identifier );
void db_add_file_ident(uint32_t file_adr, uint32_t ident_adr);
 int db_has_file_ident(uint32_t file_adr, uint32_t ident_adr);

#define do_string(x)
#define do_struct2(x)\
void save_database_chain_ ## x (void* add\
				, void* (* NEXT_CHAIN_ITEM) (void *chain)\
				, int (* WRITE_CHAIN_ITEM) (file_t* file, uint32_t kam, void* co)\
      		                , uint32_t ( *GET_IDENTIFIER) (void* item)\
		                , unsigned int item_length);\
void test_saved_database_ ## x (uint32_t ia\
				, uint32_t fa);\
void save_database_ ## x (uint32_t ia\
			  , uint32_t fa);\
int has_database_ ## x ( uint32_t ia, uint32_t fa);\
int get_database_ ## x (const char* ident);


#define do_struct4(x)\
void save_database_chain_ ## x (void* add\
				, void* (* NEXT_CHAIN_ITEM) (void *chain)\
				, int (* WRITE_CHAIN_ITEM) (file_t* file, uint32_t kam, void* co)\
      		                , uint32_t ( *GET_IDENTIFIER) (void* item)\
		                , unsigned int item_length);\
void test_saved_database_ ## x (uint32_t ia\
				, uint32_t fa\
				, uint32_t l\
				, uint32_t p);\
void save_database_ ## x (uint32_t ia\
			  , uint32_t fa\
			  , uint32_t l\
			  , uint32_t p);\
int has_database_ ## x ( uint32_t ia, uint32_t fa, uint32_t l, uint32_t p);\
int get_database_ ## x (const char* ident);

#define do_struct7(x)\
void save_database_chain_ ## x (void* add\
				, void* (* NEXT_CHAIN_ITEM) (void *chain)\
				, int (* WRITE_CHAIN_ITEM) (file_t* file, uint32_t kam, void* co)\
      		                , uint32_t ( *GET_IDENTIFIER) (void* item)\
		                , unsigned int item_length);\
void test_saved_database_ ## x  (\
				  uint32_t ident_adr,\
				  uint32_t filename_adr,\
				  uint32_t line, uint32_t pos,\
				  uint32_t dec_filename_adr,\
				  uint32_t dec_line, uint32_t dec_pos);\
void save_database_ ## x  (\
                                  uint32_t ident_adr,\
				  uint32_t filename_adr,\
				  uint32_t line, uint32_t pos,\
				  uint32_t dec_filename_adr,\
				  uint32_t dec_line, uint32_t dec_pos);\
int has_database_ ## x  (\
				  uint32_t ident_adr,\
				  uint32_t filename_adr,\
				  uint32_t line, uint32_t pos,\
				  uint32_t dec_filename_adr,\
				  uint32_t dec_line, uint32_t dec_pos);\
int get_database_ ## x (const char* ident);

#define table(tab, unused, typ) DO_STRUCT(tab,typ)
#define DO_STRUCT(tab,typ) DODO_STRUCT(tab,typ)
#define DODO_STRUCT(tab,typ) do_ ## typ (tab)

/* funkce  definovany v fn_template.h*/
TABLES

#undef do_struct2
#undef save_struct2
#undef saved_struct2
#undef get_struct2
#undef do_struct4
#undef save_struct4
#undef saved_struct4
#undef get_struct4
#undef save_struct7
#undef saved_struct7
#undef get_struct7
#undef do_struct7
#undef table
#undef DO_STRUCT
#undef DODO_STRUCT



const char** get_database_struct_def_files (const char* ident);
void database_find_unused_variable();
void database_find_unused_include ();


char** get_all_includes(const char* filename);



#ifndef __FILE_ITEM_TEMPLATE_TYPEDEF
#define __FILE_ITEM_TEMPLATE_TYPEDEF
typedef struct file_item_struct file_item;
#endif

uint32_t get_file_item_identifier(const void* item);
uint32_t get_file_item_filename(const void* item);

#endif

