/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

//#define STRING_GET_CHECK

#include "base/macros.h"
static uint32_t adr_callback_db_find_string;
static uint32_t get_callback_db_find_string()
{
  return adr_callback_db_find_string;
}
static int callback_db_find_string(uint32_t adr)
{
  //  printf("called\n");
  if (!adr_callback_db_find_string)
    adr_callback_db_find_string=adr;
  return 0;
}
/* vraci realnou adresu (v representaci integeru jaka je na dane platforme)*/
uint32_t db_find_string( //hash_table* table,
			 const char* string)
{
  hash_table* table = & identifier;
  adr_callback_db_find_string=0;
/*   printf("db_find string\n"); */
/*   printf("i_folder_address=%X\n",be2int(**table->i_folder_address)); */
  uint32_t a = find(table,string,callback_db_find_string,0);
  if (!a) return 0;

#ifdef STRING_GET_CHECK
  {
    file_t* file=table->file;
    const char* s = read_string(file,get_callback_db_find_string());
    if (!strcmp(s,string)) 
      {
	printf("check : string '%s'(%X) == '%s'\n",	
	       s
	       , get_callback_db_find_string()
	       , string);

	return s - file->realfile;
      }
    else 
      {
	printf("string '%s' adress %X, but i was seeking '%s'\n"
	       , s
	       , get_callback_db_find_string()
	       , string
	       );
	ABORT
      }
  }
#endif
  return get_callback_db_find_string();
}

/* vraci realnou adresu (v representaci integeru jaka je na dane platforme) */
/* pokud vim ze dany string v  databazi neni, je vhodne pouzit primo db_add_string */
uint32_t db_get_string( //hash_table* table,
		        const char* string)
{
/*   printf("\n---\ngetting string %s\n",string); */
/*   hash_table* table = & identifier; */
  uint32_t adr=db_find_string(string);
  // pokud jiz v databazi existuje, nevkjladam jej
  if (adr) return adr;

  // pokud neexistuje vlozim jej
  uint32_t add=db_add_string(string);

#ifdef TEST_ADD_STRING
  uint32_t adr2=db_find_string(string);
  if (adr2!=add)
    {
      printf("inserted string differs from found  insert(add)=%X found(adr2)=%X\n",add,adr2);
      abort();
    }
#endif
  return add;
}

/* vraci realnou adresu (v representaci integeru jaka je na dane platforme)*/
uint32_t db_add_string( //hash_table* table,
			const char* string)
{
/*   printf("adding string %s\n",string); */
  hash_table* table = & identifier;
  file_t* file=table->file;
  int free_space = PAGE_SIZE;
  uint32_t ad = 0;
  
  /* jeste neni stranka naalokovana */
  if (!(ad=read_int(file,STRING_FREE_PAGE))) { free_space=0; goto skip; }
  

  /* preskoci ve strance jiz ulozene stringy */
  uint32_t ad1 = read_int(file,STRING_FRST_FREE);
  if (ad1<ad 
      || ad+PAGE_SIZE<ad1)  
    { free_space=0; goto skip; }

  if (ad1)
    {
      free_space -= ad1 - ad;
      ad = ad1;
    }
  else
    {
      ad = skip_string_page_head(ad);
      printf ("sem dojit nemel\n");
      ABORT
    }

 skip:
  ;
  int len=strlen(string);
  /* pokud malo mista naalokuji dalsi stranku */
  if (free_space<=len+1)
    {
      ad = page_alloc(file);
      write_int(file,STRING_FREE_PAGE, ad);

      uint32_t first_string_act = read_int(file,STRING_FRST_PAGE); // stara prvni stranka
      write_int(file, ad, first_string_act);  // nova ukaze na starou
      write_int(file,STRING_FRST_PAGE, ad);   // nova je prvni

      ad =  skip_string_page_head(ad);     

      free_space=PAGE_SIZE-skip_string_page_head(0);
      
      while (free_space<=len) // string delsi nez PAGE_SIZE
	{
	  int adr = page_alloc(file);
	  write_int(file,STRING_FREE_PAGE,adr);
	  free_space+=PAGE_SIZE;
	  fprintf(stderr,"alokuji vice!!!\n");
	  ABORT
	}
    }
  write_string(file,ad,string);

  { // ulozi adresu pro dalsi string...
    uint32_t next_ad = ad + len + 1;

    ALLIGN_STRING_ADR(next_ad,free_space);
    write_int(file,STRING_FRST_FREE,next_ad);
  }

  {
    uint32_t adr=ad;
    __item_string i;
    i.key_adr=adr;
    i.key=(char*)string; 
    i.hash=table->hash_fce(string);    
    insert(table,&i);
  }
  return ad;
}

uint32_t db_list_strings()
{
  uint32_t str_pg_adr = read_int(&file,STRING_FRST_PAGE); // first string page (in list of string pages)
  if (!str_pg_adr) return 0; /* database is empty */
  do {
    uint32_t str_adr = skip_string_page_head(str_pg_adr);
    int free_space = PAGE_SIZE - skip_string_page_head(0);
    
    while (free_space)
      {
	const char* str  = read_string(&file,str_adr);
	if (*str)
#if 0
	  printf("%s %X %X\n",str,str_adr,str_pg_adr);
#else
	  printf("%s\n",str);
#endif
	int   len        = strlen(str);
	str_adr += len + 1;
	free_space -= len + 1;
	ALLIGN_STRING_ADR(str_adr,free_space);
      }
  } while ( (str_pg_adr = read_int(&file,str_pg_adr) ));
  return 0;
}

char*    db_generator_next_string(int reset)
{
  static uint32_t str_pg_adr;
  static uint32_t str_adr;
  static int running;
  static int end;
  static int free_space;
  if (reset) { 
    str_pg_adr = read_int(&file,STRING_FRST_PAGE); // stara prvni stranka
    running    = 0;
    end        = 0;
    str_adr    = 0;
    free_space = 0;
    return 0;
  } else {
    if (end) return 0;
    if (running) goto cycle_next;
    running=1;
  }


  do {
    str_adr = skip_string_page_head(str_pg_adr);
    
    if (!str_pg_adr) return 0; /* database is empty */

    free_space = PAGE_SIZE-(str_adr-str_pg_adr);
    
    //    while ( PAGE_SIZE-(str_adr-str_pg_adr) >0)
    while ( free_space >0)
      {
	const char* str  = read_string(&file,str_adr);
	//	if (*str) printf("%s %X %X\n",str,str_adr,str_pg_adr);
	int   len        = strlen(str);
	str_adr    += len + 1;
	free_space -= len+1;
	ALLIGN_STRING_ADR(str_adr,free_space);
/* 	if ( PAGE_SIZE-(str_adr-str_pg_adr) <=0)  */
/* 	  { */
/* 	    printf("end of %X at %X\n",str_pg_adr,str_adr); */
/* 	    break; */
/* 	  } */
/* 	if(!*str)  */
/* 	  { */
/* 	    printf("POZOR!!! at %X\n",str_adr); */
/* 	    break; */
/* 	  } */
	if ( *str)
#if 0
	  return "";
#else
	  return (char*) str;
#endif
	else 
	  continue;
      cycle_next: ;
      }
  } while ( (str_pg_adr = read_int(&file,str_pg_adr) ));
  end=1;
  return 0;
}
