/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <netinet/in.h>
#include <errno.h>

#include "memsave.h"

#include "database/templates/hash_algo.h"
#include "database/database.h"

#include "base/xalloc.h"
#include "base/cmd.h"

extern int test_already_inserted;

#include "rb/string.h"
#include "rb/file.h"
#include "rb/struct.h"


static void add_file_ident( string_t* file_s, string_t* ident_s);
static void save_sfile_t  ();
static void save_struct_t ();
static void save_strings  ();

/* 
   pokud normalni build tak vsechny nastaveny na 0 
   pokud update tak smaznout z databaze - nastavit add_deleted_files
 */

int db_have_strings; 
/* database already contains strings - check before inserting ... */

const char** readd_deleted_files; 
/* i won't have to check if they are in db for they are not */

int not_add_include_into_db; /* 1 if should add includes as well */

static void build_reinit()
{
  file_destroy()   ;
  struct_destroy() ;
  init_file()   ;
  init_struct() ;  
  if (!remember_strings) 
    { 
      string_destroy () ;
      init_string    () ;
    }
}

void build_init()
{
  init_string () ;
  init_file   () ;
  init_struct () ;  
}

void build_destroy()
{
  file_destroy()   ;
  string_destroy() ;
  struct_destroy() ;
}

void build_all_save()
{
  save_strings();
  save_struct_t();
  save_sfile_t();
}

void build_one_save()
{

  int i            =   remember_strings;
  remember_strings = 0;
  save_strings();
  remember_strings =   i;

#ifdef MY_WARNS
#warning urychlit -> checkovat pri save
#endif
  check_struct_t();
  save_struct_t ();

  check_sfile_t();
  save_sfile_t ();
}

void build_update_save()
{

  int i            =   remember_strings;
  remember_strings = 0;
  save_strings();
  remember_strings =   i;

#if 0
  check_struct_t();
  save_struct_t ();

  check_sfile_t();
  save_sfile_t ();
#else  
  /* vse co je v databazi bylo updatem vymazano ... neni treba kontrolovat */
  save_struct_t();

  check_sfile_t();
  save_sfile_t ();
#endif
}


void build_drop()
{
  build_reinit();
}


void mem_find_unused_variable ( )
{ 
  TREE_FOR_ALL( variable_dec , & tree_variable_dec , add)
    {
      string_t* id_s = add->ident;
      record_variable_use *item = 
	variable_use_find (& tree_variable_use , id_s);
      
#ifdef MY_WARNINGS
#warning nezkontrolovana funkcnost
#endif
      if (!item) 
	/* 
	   kontroluji pouze identifikatory 
	   - pozor na static - pokud je i extern i static deklarace 
	       a extern je statickou zakryta?
	   pak extern se tvrdi ze je pouzita i pokud neni...
	      nemyslim ze je to pravda pri vkladani do databaze 
	      kontroluju misto deklarace
	*/
	{
	  printf("unused variable ");
	  WRITE4(add->ident->str,add->file->str,add->line,add->pos);
	}
    }
  TREE_END_FOR;
}

void mem_find_unused_function_def ( )
{ 
  TREE_FOR_ALL( function_def , & tree_function_def , add)
    {
      string_t* id_s = add->ident;
      record_function_use *item = 
	function_use_find (& tree_function_use , id_s);
      
#ifdef MY_WARNINGS
#warning nezkontrolovana funkcnost
#endif
      if (!item) 
	{
	  printf("unused function ");
	  WRITE4(add->ident->str,add->file->str,add->line,add->pos);
	}
    }
  TREE_END_FOR;
} 

#define AB printf("not supported yet\n"); ABORT;

void mem_find_unused_include  ( )
{
#ifdef MY_WARNINGS
#warning posoudit vyuzitelnost unsused_include ...
#endif
  AB;
}


