/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#include <string.h>
#include <stdio.h>
#include "add-fce.h"

extern int   no_system_includes; /* config.c */

int fce_inline_deactivate;
int fce_use_deactivate;
int fce_def_deactivate;
int fce_dec_deactivate;
int var_dec_deactivate;
int var_use_deactivate;
int incl_deactivate;
int mac_def_deactivate;
int mac_use_deactivate;
int mac_defd_deactivate;
int mac_udef_deactivate;
int str_dec_deactivate;
int str_def_deactivate;
int str_use_deactivate;
int uni_dec_deactivate;
int uni_def_deactivate;
int uni_use_deactivate;
int tdef_deactivate;
int tdef_use_deactivate;
int cast_deactivate;
int add_struct_member_deactivate;

extern void (*add_cast)          (struct expression* );
extern void (*add_struct_member) (struct expression* );
extern void (*add_function_use)  (struct symbol* act_fn, struct expression *expr);
extern void (*add_function_call) (struct symbol* sym, struct expression* ) ;
extern void (*add_function_def)  (struct symbol* )     ;
extern void (*add_function_inline)  (struct symbol* )     ;
extern void (*add_function_dec)  (struct symbol* )     ;
extern void (*add_static_variable_dec)  (struct symbol*, struct symbol* )     ;
extern void (*add_variable_dec)  (struct symbol*, struct symbol* )     ;
extern void (*add_variable_use)  (struct symbol*, struct expression* ) ;
extern void (*add_include)         (const char* , struct token* ) ;
extern void (*add_macro_define)    (struct symbol* ) ;
extern void (*add_macro_use)       (struct symbol*, struct token* ) ;
extern void (*add_macro_defined)   (struct token* )      ;
extern void (*add_macro_undef)     (struct token* )      ;
extern void (*add_struct_dec)      (struct symbol* ) ;
extern void (*add_struct_def)      (struct symbol* ) ;
extern void (*add_struct_use)      (struct token* , struct position* ) ;
extern void (*add_union_dec)      (struct symbol* ) ;
extern void (*add_union_def)      (struct symbol* ) ;
extern void (*add_union_use)      (struct token* , struct position* ) ;
extern void (*add_typedef_)     (struct symbol* ) ;
extern void (*add_typedef_use)  (struct symbol* , struct position*) ;
extern void (*add_symbol_at) (struct symbol*);
extern void (*add_nothing_at)        (struct position );
extern void (*add_evaluate_expression) (struct symbol*, struct expression *);


static void add_CAST       (struct expression* );
static void add_STRUCT_member (struct expression* expr);
static void add_fce_inline (struct symbol* );
static void add_fce_use    (struct symbol* , struct expression* ) ;
static void add_fce_def    (struct symbol* ) ;
static void add_fce_dec    (struct symbol* ) ;
static void add_incl       (const char* , struct token* ) ;
static void add_var_dec    (struct symbol*, struct symbol* )     ;
static void add_var_use    (struct symbol*, struct expression* ) ;
static void add_mac_def    (struct symbol* ) ;
static void add_mac_use    (struct symbol*, struct token* ) ;
static void add_mac_defd   (struct token* )      ;
static void add_mac_udef   (struct token* )      ;
static void add_str_dec    (struct symbol* ) ;
static void add_str_def    (struct symbol* ) ;
static void add_str_use    (struct token* , struct position* ) ;
#ifdef UNIONS
static void add_uni_dec    (struct symbol* ) ;
static void add_uni_def    (struct symbol* ) ;
static void add_uni_use    (struct token* , struct position* ) ;
#endif
static void add_tdef       (struct symbol* ) ;
static void add_tdef_use   (struct symbol* , struct position* ) ;

add_fce_t add_fce;
static int local_var_dec     (struct symbol* fn, struct symbol* ) ;
static int local_var_use     (struct symbol* fn, struct expression* ex) ;
static void add_static_var_dec       (struct symbol* fn, struct symbol*  sym);

int inside_project(int s);
int system_include(int s);

static add_fce_t backup;
static void init_fce() 
{
  fce_inline_deactivate=0;
  fce_use_deactivate=0;
  fce_def_deactivate=0;
  fce_dec_deactivate=0;
  var_dec_deactivate=0;
  var_use_deactivate=0;
  incl_deactivate=0;
  mac_def_deactivate=0;
  mac_use_deactivate=0;
  mac_defd_deactivate=0;
  mac_udef_deactivate=0;
  str_dec_deactivate=0;
  str_def_deactivate=0;
  str_use_deactivate=0;
  tdef_deactivate=0;
  tdef_use_deactivate=0;
  cast_deactivate=0;
  add_struct_member_deactivate=0;

  memset(&add_fce,0,sizeof(add_fce_t));


  add_function_use   = add_fce_use;
  add_function_call  = 0;
  add_function_def   = add_fce_def;
  add_function_inline= add_fce_inline;
  add_function_dec   = add_fce_dec;

  add_variable_dec   = add_var_dec;
  add_static_variable_dec  = add_static_var_dec;
  add_variable_use   = add_var_use;

  add_include        = add_incl;
  add_cast           = add_CAST;
  add_struct_member  = add_STRUCT_member;
  add_macro_define   = add_mac_def;
  add_macro_use      = add_mac_use;
  add_macro_defined  = add_mac_defd;
  add_macro_undef    = add_mac_udef;
  add_struct_dec     = add_str_dec;
  add_struct_def     = add_str_def;
  add_struct_use     = add_str_use;
/*   add_union_dec      = add_uni_dec; */
/*   add_union_def      = add_uni_def; */
/*   add_union_use      = add_uni_use; */
  add_union_dec      = add_str_dec;
  add_union_def      = add_str_def;
  add_union_use      = add_str_use;

  add_typedef_       = add_tdef;
  add_typedef_use    = add_tdef_use;
  add_symbol_at      = set_symbol_at;
  add_nothing_at     = nothing_at;
  add_typedef_use    = add_tdef_use;

  add_fce.cond_var_use = local_var_use;
  add_fce.cond_var_dec = local_var_dec;

}

void add_push() {
  backup=add_fce;
  memset(&add_fce,0,sizeof(add_fce_t));
  //  init_fce();
}

void add_pop() {
  add_fce=backup;
}

void add_init() 
{
  init_fce();
  //  add_function_dec   = 0;
}

static void add_fce_inline    (struct symbol* sym)
{
  if (fce_inline_deactivate) return;
  if (!sym || !sym->ident) return;
  if ( sym->type!=SYM_FN && sym->type!=SYM_NODE)
    {
      fprintf(stderr,"database save function_def says : not a function...\n");
      return;
    }
  if (!add_fce.cond_fce_inline || add_fce.cond_fce_inline(sym))
    if (add_fce.action_fce_inline) add_fce.action_fce_inline(sym);
}
static void add_fce_use       (struct symbol*  fn, struct expression* expr) 
{
  // todo - umoznit abych nevkladal systemove funkce...
  if (fce_use_deactivate) return;
  if (!expr || !expr->symbol) return;
  if (expr->type!=EXPR_SYMBOL) return; /* spatne zavolano */
  struct symbol* sym=expr->symbol->ctype.base_type;
  if (!sym || sym->type!=SYM_FN) return; /* spatne zavolano */
  if (!add_fce.cond_fce_use || add_fce.cond_fce_use(fn,expr))
    if (add_fce.action_fce_use) add_fce.action_fce_use(fn,expr);
}
static void add_fce_def       (struct symbol*  sym) 
{
  if (fce_def_deactivate) return;
  if ( !sym || !sym->ident ) return;
  if ( sym->type != SYM_FN && sym->type != SYM_NODE)
    {
      fprintf(stderr,"database save function_def says : not a function...\n");
      return;
    }
  if (!add_fce.cond_fce_def || add_fce.cond_fce_def(sym))
    if (add_fce.action_fce_def) add_fce.action_fce_def(sym);
}
static void add_fce_dec       (struct symbol*  sym) 
{
  if (fce_dec_deactivate) return;
  if (!sym || !sym->ident) return;
  if ( sym->type!=SYM_FN && sym->type!=SYM_NODE)
    {
      fprintf(stderr,"database save function_def says : not a function...\n");
      return;
    }

  if (!sym->pos.stream || (no_system_includes && system_include(sym->pos.stream))) return;
  if (!add_fce.cond_fce_dec || add_fce.cond_fce_dec(sym))
    if( add_fce.action_fce_dec)  add_fce.action_fce_dec(sym);
  
}

static void add_static_var_dec       (struct symbol* fn, struct symbol*  sym)     
{
  if (var_dec_deactivate) return;
  if (!sym || !sym->ident) return;

  if ((!sym->pos.stream || (no_system_includes && system_include(sym->pos.stream)))) return;
#ifdef MY_WARNINGS
#warning pro staticke i nestaticke promenne se chova stejne...
#endif
  if (!add_fce.cond_var_dec || add_fce.cond_var_dec(fn,sym)) {
    if (add_fce.action_var_dec) add_fce.action_var_dec(fn,sym);
    //    output_variable_dec(fn,sym);
  }
}

static void add_var_dec       (struct symbol* fn, struct symbol*  sym)     
{
  if (var_dec_deactivate) return;
  if (!sym || !sym->ident) return;

  if (!sym->pos.stream || (no_system_includes && system_include(sym->pos.stream))) return;
  if (!add_fce.cond_var_dec || add_fce.cond_var_dec(fn,sym)) {
    if (add_fce.action_var_dec) add_fce.action_var_dec(fn,sym);
  }
}
static void add_var_use       (struct symbol* fn, struct expression* ex)  
{
  if (var_use_deactivate) return;
  if (!ex || !ex->symbol) return; 
  //  if (!fn ) return; // 

  //  if (! ex->pos.stream ) return;

  if (!ex->pos.stream || (no_system_includes && system_include(ex->pos.stream))) return;
  if (!ex->symbol->pos.stream || (no_system_includes && system_include(ex->symbol->pos.stream))) return;

  // test zda jde o lokalni promennou
  /* lokalni=ve stejnem souboru, a funkce zacina drive nez je promenna deklarovana*/
  if (!add_fce.cond_var_use || add_fce.cond_var_use(fn,ex))
    if (add_fce.action_var_use) add_fce.action_var_use(fn,ex);
#if 0
  printf("%p %p  ",fn,ex);
  output_variable_use(fn,ex);
#endif
}
static void add_incl          (const char* file, struct token*  tok) 
{
  if (incl_deactivate) return;
  if (!tok || !file) return;
  if (!add_fce.cond_incl || add_fce.cond_incl(file,tok))
    if (add_fce.action_incl) add_fce.action_incl(file,tok);

}
static void add_mac_def  (struct symbol*  sym) 
{
  if (mac_def_deactivate) return;
  if (!sym || !sym->ident) return;

  if (!sym->pos.stream || (no_system_includes && system_include(sym->pos.stream))) return;
  if (!add_fce.cond_mac_def || add_fce.cond_mac_def(sym))
    if (add_fce.action_mac_def) add_fce.action_mac_def(sym);

}
static void add_mac_use     (struct symbol*  sym, struct token*  tok) 
{
  if (mac_use_deactivate) return;
  if (!sym || !sym->ident) return;

  if (!sym->pos.stream || (no_system_includes && system_include(sym->pos.stream))) return;
  if (!add_fce.cond_mac_use || add_fce.cond_mac_use(sym,tok))
    if (add_fce.action_mac_use) add_fce.action_mac_use(sym,tok);

}
static void add_mac_defd (struct token*  tok)      
{
  if (mac_defd_deactivate) return;
  if (!tok || !tok->ident) return;

  if (!tok->pos.stream || (no_system_includes && system_include(tok->pos.stream))) return;
  if (!add_fce.cond_mac_use || add_fce.cond_mac_use(0,tok))
    if (add_fce.action_mac_use) add_fce.action_mac_use(0,tok);
}
static void add_mac_udef   (struct token*  tok)      
{
  if (mac_udef_deactivate) return;
  ;
}


#ifdef UNIONS
static void add_uni_dec    (struct symbol*  sym) 
{
  if (uni_dec_deactivate) return;
  if (!sym) return;
  if (!sym->ident) return;

  if (!sym->pos.stream || (no_system_includes && system_include(sym->pos.stream))) return;
  if (!add_fce.cond_uni_dec || add_fce.cond_uni_dec(sym))
    if (add_fce.action_uni_dec) add_fce.action_uni_dec(sym);

}
static void add_uni_def    (struct symbol*  sym) 
{
  if (uni_def_deactivate) return;
  if (!sym) return;
  if (!sym->ident) return;

  if (!sym->pos.stream || (no_system_includes && system_include(sym->pos.stream))) return;
  if (!add_fce.cond_uni_def || add_fce.cond_uni_def(sym))
    if (add_fce.action_uni_def) add_fce.action_uni_def(sym);

}
static void add_uni_use    (struct token* token, struct position* pos) 
{
  if (uni_use_deactivate) return;
  if (!token) return;
  if (!token->ident) return;

  if (!sym->pos.stream || (no_system_includes && system_include(token->pos.stream))) return;
  if (!add_fce.cond_uni_use || add_fce.cond_uni_use(token,pos))
    if (add_fce.action_uni_use) add_fce.action_uni_use(token,pos);
}
#endif

static void add_str_dec    (struct symbol*  sym) 
{
  if (str_dec_deactivate) return;
  if (!sym) return;
  if (!sym->ident) return;

  if (!sym->pos.stream || (no_system_includes && system_include(sym->pos.stream))) return;
  if (!add_fce.cond_str_dec || add_fce.cond_str_dec(sym))
    if (add_fce.action_str_dec) add_fce.action_str_dec(sym);
}

static void add_str_def    (struct symbol*  sym) 
{
  if (str_def_deactivate) return;
  if (!sym) return;
  if (!sym->ident) return;

  if (!sym->pos.stream || (no_system_includes && system_include(sym->pos.stream))) return;
  if (!add_fce.cond_str_def || add_fce.cond_str_def(sym))
    if (add_fce.action_str_def) add_fce.action_str_def(sym);

}

static void add_str_use    (struct token* token, struct position* pos) 
{
  if (str_use_deactivate) return;
  if (!token) return;
  if (!token->ident) return;

  if (!token->pos.stream || (no_system_includes && system_include(token->pos.stream))) return;
  if (!add_fce.cond_str_use || add_fce.cond_str_use(token,pos))
    if (add_fce.action_str_use) add_fce.action_str_use(token,pos);
}
static void add_tdef      (struct symbol*  sym) 
{
  if (tdef_deactivate) return;
  if (!sym||!sym->ident) return;
  if (!inside_project(sym->pos.stream)) return;

  if (!sym->pos.stream || (no_system_includes && system_include(sym->pos.stream))) return;
  if (!add_fce.cond_tdef || add_fce.cond_tdef(sym))
    if (add_fce.action_tdef) add_fce.action_tdef(sym);

}
static void add_tdef_use   (struct symbol*  sym, struct position* pos) 
{
  if (tdef_use_deactivate) return;
  if (!sym||!sym->ident) return;

  if (!inside_project(sym->pos.stream)) return;
  if (!inside_project(pos->stream)) return;

  if (!sym->pos.stream || (no_system_includes && system_include(sym->pos.stream))) return;
  if (!sym->pos.stream || (no_system_includes && system_include(pos->stream))) return;

  if (!add_fce.cond_tdef_use || add_fce.cond_tdef_use(sym,pos))
    if (add_fce.action_tdef_use) add_fce.action_tdef_use(sym,pos);
}

void set_symbol_at     (struct symbol*  sym) 
{
  if (!add_fce.cond_symbol_at || add_fce.cond_symbol_at(sym))
    if(add_fce.action_symbol_at) 
      add_fce.action_symbol_at(sym);
}

void set_token_at      (struct token*  tok) 
{}
void set_expression_at (struct expression* ex)
{}
void set_scope_at      (struct scope* s)  
{}

void nothing_at (struct position pos)
{
  if (!add_fce.cond_nothing_at || add_fce.cond_nothing_at(pos))
    if(add_fce.action_nothing_at) 
      add_fce.action_nothing_at(pos);
}
     
static int local_var_use     (struct symbol* fn, struct expression* ex) 
{
  if ( !(ex->symbol->ctype.modifiers & MOD_NONLOCAL))
    return 0;
  else
    return 1;

  if ( fn->pos.stream == ex->symbol->pos.stream
       && ( fn->pos.line<ex->symbol->pos.line ||
	    ( fn->pos.line==ex->symbol->pos.line &&
	      fn->pos.pos<=ex->symbol->pos.pos)))
    return 0;
  else 
    return 1;
}

static int local_var_dec   (struct symbol* fn, struct symbol*  sym)   
{
  if (fn) return 0;  // lokalni promenne
  else return 1;
}


static void add_CAST          (struct expression* expr)
{
  if (cast_deactivate) return;
  if (!expr ) return;
  if (!add_fce.cond_cast || add_fce.cond_cast(expr))
    if (add_fce.action_cast) add_fce.action_cast(expr);
}

static void add_STRUCT_member (struct expression* expr)
{
  if (add_struct_member_deactivate) return;
  if (!expr ) return;
  if (!add_fce.cond_struct_member || add_fce.cond_struct_member(expr))
    if (add_fce.action_struct_member) add_fce.action_struct_member(expr);
}
