/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#define IDENT_NAME(x) called_by_ ## x

static const char* IDENT_NAME(file);
static int         IDENT_NAME(line);
static int         IDENT_NAME(pos);
static int         IDENT_NAME(inside_fn);

static int IDENT_NAME(function_printed);
static struct position IDENT_NAME(nothing_position);

static void IDENT_NAME(nothing_at)        (struct position pos)
{
  IDENT_NAME(nothing_position)=pos;
}

static void IDENT_NAME(symbol_at) (struct symbol* s) 
{
  static struct symbol* p;
  //  printf("1 ... start \n");
  if (IDENT_NAME(function_printed)) return; //goto end;
  //  printf("2 ... not printed yet\n");
  if (!s && p) { 
    //    printf("\n\n\nin the end\n");
    goto ok; 
  }
  if (!p && s) { 
    if (s && strcmp(stream_name(s->pos.stream),IDENT_NAME(file))) 
      {
	return;
      }
    p=s;  
    return; 
  }
  if (!s && !p ) return; // napr. spatne zadany soubor
  if (s->ctype.base_type && s->ctype.base_type->type==SYM_FN)
    {
      if (s->pos.line>IDENT_NAME(line))
	{
	  if(p && p->pos.line<=IDENT_NAME(line))
	    {
	    ok:
	      IDENT_NAME(inside_fn)=1;
	      add_function(fce_use, output_function_use, 0);
	      
	      if (p) { /* chci tisknout predchozi funkci */
		if (!(
		      IDENT_NAME(nothing_position).line < IDENT_NAME(line) 
		      ||( IDENT_NAME(nothing_position).line==IDENT_NAME(line)
			  && IDENT_NAME(nothing_position).pos < IDENT_NAME(pos))
		      )) /* nechci aby tisklo funkci pokud jsem je jiz ukoncena */
		    traverse_function(p
				      , 0 /* will print entire function */
				      //, IDENT_NAME(line) /* will print just previous parts */
				      , IDENT_NAME(pos));
	      //walk_function(p); // projde sparse strom a vytiskne jen to co potrebuji
	      }
	      IDENT_NAME(function_printed)++;
	      add_function(fce_use, 0, 0);
	    }
	}
      //      printf("end...\n\n\n\n\n\n\n\n");
      p=s;
    }
}

void get_called_by_function_at(const char* filename, int line, int pos)
{
  add_push();
  char* f = malloc ( strlen(filename) +1 );
  strcpy(  f, filename);

  IDENT_NAME(inside_fn)   = 0;
  IDENT_NAME(file) = f;
  IDENT_NAME(line) = line;
  IDENT_NAME(pos)  = pos;

  //  add_function(fce_use,    output_function_use, 0);

  add_function(symbol_at
	       , IDENT_NAME(symbol_at) 
	       , 0);
  add_function(nothing_at
	       , IDENT_NAME(nothing_at)
	       , 0);

  spotsparse_file(f);

  free(f);
  add_pop();
  return;

}
#undef IDENT_NAME

