#ifndef SPARSE_BUILD_DURING_SPARSE_H
#define SPARSE_BUILD_DURING_SPARSE_H

//#define show_database_evaluate_expression


static void do_statement(struct statement* stmt, int level);
static void do_call(struct expression* ex);
static void do_preop(struct expression* ex);
static void do_expression(struct expression* ex);
static void do_compound(struct statement* stmt, int level);

static void do_evaluate_expression_symbol(struct symbol* act_fn, struct expression *expr)
{
#ifdef show_database_evaluate_expression
	  printf("evaluate expression symbol ... name=%s   at %s %d:%d\n"
		 ,expr->symbol_name->name
		 ,get_filename(stream_name(expr->pos.stream))
		 ,expr->pos.line
		 ,expr->pos.pos);
#endif
	  if (expr->symbol)
	    {
#ifdef show_database_evaluate_expression
	      printf("\tsymbol type=%d\n",expr->symbol->type);
	      printf("\tsymbol base_type=%d\n"
		     ,expr->symbol->ctype.base_type?expr->symbol->ctype.base_type->type:-1);
#endif	      
	      struct symbol* sym=expr->symbol->ctype.base_type;
	      if (sym)
		switch (sym->type)
		  {
		  case SYM_UNINITIALIZED:
		    break;
		  case SYM_PREPROCESSOR:
		    printf("sym_preprocessor at %s %d:%d\n",
			   stream_name(expr->pos.stream),
			   expr->pos.line,
			   expr->pos.pos
			   );	
		    printf("zajimava situace -> prozkoumat\n");
		    ABORT;
		    break;
		  case SYM_BASETYPE:
#ifdef show_database_evaluate_expression
		    printf("base_type\n");
#endif	      
		    // zajisteno jinde?
		    //add_variable_use(act_fn,expr);
		    break;
		  case SYM_NODE:
#ifdef show_database_evaluate_expression
		    printf("node\n");
#endif	      
		    // zajisteno jinde?
		    //add_variable_use(act_fn,expr);
		    break;
		  case SYM_PTR:
#ifdef show_database_evaluate_expression
		    printf("ptr\n");
#endif	      
		    // zajisteno jinde
		    //		    add_variable_use(act_fn,expr);
		    break;
		  case SYM_FN:
		    // #warning provadi se nasparse/evaluate.c:63 - overit zda je podmnozinou  zda se byti ekvivalentni
		    // jiz zajisteno jinde
		    //		    add_function_use(act_fn,expr);

#ifdef show_database_evaluate_expression
		    /* dava mi vsechna pouziti dane funkce --- predani adresy*/
		    printf("function %s at %s %d:%d expr at %s %d:%d\n",
			   sym->ident?sym->ident->name:expr->symbol_name->name,
			   stream_name(sym->pos.stream),
			   sym->pos.line,
			   sym->pos.pos,
			   stream_name(expr->pos.stream),
			   expr->pos.line,
			   expr->pos.pos
			   );
#endif	      
		    break;
		  case SYM_ARRAY:
#ifdef show_database_evaluate_expression
		    printf("array\n");
#endif	      
		    // zajisteno jinde?
		    //add_variable_use(act_fn,expr);
		    break;
		  case SYM_STRUCT:
#ifdef show_database_evaluate_expression
		    printf("struct expression at %s %d:%d\n",
			   stream_name(expr->pos.stream),
			   expr->pos.line,
			   expr->pos.pos
			   );		   
#endif

#warning ?neni zajisteno jinde?
		    add_variable_use(act_fn,expr);
		    break;
		  case SYM_UNION:
#ifdef show_database_evaluate_expression
		    printf("union\n");
#endif      
		    // zajisteno jinde?
		    //add_variable_use(act_fn,expr);
		    break;
		  case SYM_ENUM:
#ifdef show_database_evaluate_expression
		    printf("enum\n");
#endif
		    // zajisteno jinde?
		    //add_variable_use(act_fn,expr);
		    break;
		  case SYM_TYPEDEF:
#ifdef show_database_evaluate_expression
		    printf("typedef\n");
#endif	      
		    // zajisteno jinde?
		    //add_variable_use(act_fn,expr);
		    break;
		  case SYM_TYPEOF:
#ifdef show_database_evaluate_expression
		    printf("typeof\n");
#endif
		    break;
		  case SYM_MEMBER:
#ifdef show_database_evaluate_expression
		    printf("symmember\n");
#endif	      
		    break;
		  case SYM_BITFIELD:
#ifdef show_database_evaluate_expression
		    printf("bitfield\n");
#endif	      
		    break;
		  case SYM_LABEL:
#ifdef show_database_evaluate_expression
		    printf("label\n");
#endif	      
		    break;
		  case SYM_RESTRICT:
#ifdef show_database_evaluate_expression
		    printf("restrict\n");
#endif	      
		    break;
		  case SYM_BAD:
#ifdef show_database_evaluate_expression
		    printf("bad\n");
#endif	      
		    break;
		  }
	    }
	  else 
	    {
#ifdef show_database_evaluate_expression
	      printf("!!!!! symbol=0 !!!!!!!! prozkoumat\n");
#endif
	    }
}

static void do_evaluate_expression_string(struct symbol* act_fn, struct expression *expr)
{
#ifdef show_database_evaluate_expression
  printf("evaluate expression string ... string=%s   at %s %d:%d\n"
	 ,expr->string->data
	 ,get_filename(stream_name(expr->pos.stream))
	 ,expr->pos.line
	 ,expr->pos.pos);
#endif
}
static void do_evaluate_expression(struct symbol* act_fn, struct expression *expr)
{
#ifdef show_database_evaluate_expression
  printf("----------------------------\n");
#endif
  /* plne vyreseno v sparse/evaluate.c:54 */
	if (!expr)         return ;
	//	if (expr->ctype)   return ;
	switch (expr->type) {
	case EXPR_VALUE:
	case EXPR_FVALUE:       return ;
	case EXPR_STRING:       do_evaluate_expression_string(act_fn,expr) ; return ;
	case EXPR_SYMBOL:       do_evaluate_expression_symbol(act_fn, expr); return ;
	case EXPR_BINOP:	return ;
	case EXPR_LOGICAL:	return ;
	case EXPR_COMMA:	return ;
	case EXPR_COMPARE:	return ;
	case EXPR_ASSIGNMENT:	return ;
	case EXPR_PREOP:        do_preop(expr);	return ;
	case EXPR_POSTOP:	return ;
	case EXPR_CAST:         add_cast(expr);
	case EXPR_IMPLIED_CAST:	return ;
	case EXPR_SIZEOF:	return ;
	case EXPR_PTRSIZEOF:	return ;
	case EXPR_ALIGNOF:	return ;
	case EXPR_DEREF:	return ;
	case EXPR_CALL:         do_call(expr);  return ;
	case EXPR_STATEMENT:    do_statement(expr->statement,0); return ;
	case EXPR_SELECT:
	case EXPR_CONDITIONAL:  return ;
	case EXPR_LABEL:        return ;
	case EXPR_TYPE:	        return;
	/* These can not exist as stand-alone expressions */
	case EXPR_INITIALIZER:
	case EXPR_IDENTIFIER:
	case EXPR_INDEX:
	case EXPR_POS:   	  return;
	case EXPR_SLICE:	  return;
	}
	return ;
}


static void do_statement(struct statement* stmt, int level)
{
  if (!stmt) return;
#ifdef PRINT_DEBUG
  printf("statement\n");
#endif
  switch ( stmt->type )
    {
    case STMT_DECLARATION:
      {
#ifdef MY_WARNINGS
#warning prozkoumat co presne znamena stmt_declaration
#endif
#ifdef PRINT_DEBUG
	printf("declaration at %s %d:%d\n"
	       ,stream_name(stmt->pos.stream)
	       ,stmt->pos.line
	       ,stmt->pos.pos
	       );
#endif
	struct symbol* s;
	FOR_EACH_PTR(stmt->declaration, s) {
	  add_variable_dec(act_fn,s);
	} END_FOR_EACH_PTR(s);
	break;
      }
    case STMT_COMPOUND:
      do_compound(stmt,level);
      break;
    case STMT_NONE:
      {
	break;
      }
    case STMT_EXPRESSION:
      {
	do_expression(stmt->expression);
	break;
      }
    case STMT_IF:
      {
	do_expression(stmt->if_conditional);
	do_statement(stmt->if_true,level+1);
	do_statement(stmt->if_false,level+1);
	break;
      }
    case STMT_CASE:
      {
	do_expression(stmt->case_expression);
	do_statement(stmt->case_statement,level+1);
	break;
      }
    case STMT_SWITCH:
      {
	do_expression(stmt->switch_expression);
	do_statement(stmt->switch_statement,level+1);
	break;
      }
    case STMT_ITERATOR:
      {
	do_statement (stmt->iterator_pre_statement,level+1);
	do_expression(stmt->iterator_pre_condition);
	do_statement (stmt->iterator_statement,level+1);
	do_statement (stmt->iterator_post_statement,level+1);
	do_expression(stmt->iterator_post_condition);
	break;
      }
    case STMT_LABEL:
      {
	// struct symbol *label;
	// struct statement *label_statement;
/* 	printf("level=%d ... label at %d:%d\n",level,stmt->pos.line,stmt->pos.pos); */
	break;
      }
    case STMT_GOTO:
      {
/* 	printf("level=%d ... goto at %d:%d\n",level,stmt->pos.line,stmt->pos.pos); */
	break;
      }
    case STMT_ASM:
      {
/* 	printf("level=%d ... asm at %d:%d\n",level,stmt->pos.line,stmt->pos.pos); */
	break;
      }
    case STMT_CONTEXT:
      {
/* 	printf("level=%d ... context at %d:%d\n",level,stmt->pos.line,stmt->pos.pos); */
	break;
      }
    case STMT_RANGE:
      {
	do_expression(stmt->range_expression);
	do_expression(stmt->range_low);
	do_expression(stmt->range_high);
	break;
      }
    case STMT_RETURN:
      {
	break;
      }
    default:
      break;
    }
}





static void do_call(struct expression* ex)
{
#ifdef PRINT_DEBUG
  printf("do call\n");
#endif
  if (!ex) return;
  if (ex->type!=EXPR_CALL) return;
  do_expression(ex->fn);
  //zajisteno jinde
  //  add_function_use(act_fn,ex->fn);
}


static void do_preop(struct expression* ex)
{
#ifdef PRINT_DEBUG
  printf("do preop\n");
#endif

#define expr ex
  do_expression(ex->unop);

  if (!ex) return;
  if (ex->type!=EXPR_PREOP) return;
  struct expression *fn = ex->fn;
  struct symbol *sym, *ctype;
  sym = ctype = fn->ctype;
  if (!sym) return;
  if (ctype->type == SYM_NODE)
    ctype = ctype->ctype.base_type;
  if (ctype->type == SYM_PTR || ctype->type == SYM_ARRAY)
    ctype = get_base_type(ctype);

#ifdef NOT_A_FUNCTION
  if (ctype->type != SYM_FN) {
    warning(expr->pos, "not a function %s", show_ident(sym->ident));
    return ;
  }
#endif

  if (sym && sym->type==SYM_NODE)
    if (ctype && ctype->ctype.modifiers & MOD_INLINE)
      {
	printf("inline function\n");
      }
#undef expr
}

static void do_expression(struct expression* ex)
{
#ifdef PRINT_DEBUG
  printf("do expr\n");
#endif
  struct expression *expr = ex;
  /* plne vyreseno v sparse/evaluate.c:54 */
	if (!expr)
		return ;
	if (expr->ctype)
		return ;

	//	printf("act_fn name=%s\n",act_fn?(act_fn->ident?act_fn->ident->name:"00"):"0");
	switch (expr->type) {
	case EXPR_VALUE:
	case EXPR_FVALUE:
		return ;
	case EXPR_STRING:
#ifdef show_database_evaluate_expression
	  printf("evaluate expression string ... string=%s   at %s %d:%d\n"
		 ,expr->string->data
		 ,get_filename(stream_name(expr->pos.stream))
		 ,expr->pos.line
		 ,expr->pos.pos);
#endif
		return ;
	case EXPR_SYMBOL:
#ifdef show_database_evaluate_expression
	  printf("evaluate expression symbol ... name=%s   at %s %d:%d\n"
		 ,expr->symbol_name->name
		 ,get_filename(stream_name(expr->pos.stream))
		 ,expr->pos.line
		 ,expr->pos.pos);
#endif
	  if (expr->symbol)
	    {
#ifdef show_database_evaluate_expression
	      printf("\tsymbol type=%d\n",expr->symbol->type);
	      printf("\tsymbol base_type=%d\n"
		     ,expr->symbol->ctype.base_type?expr->symbol->ctype.base_type->type:0);
#endif
	      struct symbol* sym=expr->symbol->ctype.base_type;
	      if (sym)
		switch (sym->type)
		  {
		  case SYM_UNINITIALIZED:
		    break;
		  case SYM_PREPROCESSOR:
		    printf("sym_preprocessor at %s %d:%d\n",
			   stream_name(expr->pos.stream),
			   expr->pos.line,
			   expr->pos.pos
			   );
		    printf("zajimava situace -> prozkoumat\n");
		    ABORT;
		    break;
		  case SYM_BASETYPE:
		    break;
		  case SYM_NODE:
#ifdef show_database_evaluate_expression
		    printf("node\n");
#endif
		    //add_variable_use(act_fn,expr);
		    break;
		  case SYM_PTR:
#ifdef show_database_evaluate_expression
		    printf("ptr\n");
#endif
		    //add_variable_use(act_fn,expr);
		    break;
		  case SYM_FN:
		    // #warning provadi se nasparse/evaluate.c:63 - overit zda je podmnozinou  zda se byti ekvivalentni

		    // zajisteno jinde
		    //		    add_function_use(act_fn,expr);
#ifdef show_database_evaluate_expression
		    /* dava mi vsechna pouziti dane funkce --- predani adresy*/
		    printf("function %s at %s %d:%d expr at %s %d:%d\n",
			   sym->ident?sym->ident->name:expr->symbol_name->name,
			   stream_name(sym->pos.stream),
			   sym->pos.line,
			   sym->pos.pos,
			   stream_name(expr->pos.stream),
			   expr->pos.line,
			   expr->pos.pos
			   );
#endif
		    break;
		  case SYM_ARRAY:
		    break;
		  case SYM_STRUCT:
#if 0
		    printf("struct expression at %s %d:%d\n",
			   stream_name(expr->pos.stream),
			   expr->pos.line,
			   expr->pos.pos
			   );
#endif
		    break;
		  case SYM_UNION:
		    break;
		  case SYM_ENUM:
		    break;
		  case SYM_TYPEDEF:
		    break;
		  case SYM_TYPEOF:
		    break;
		  case SYM_MEMBER:
		    break;
		  case SYM_BITFIELD:
		    break;
		  case SYM_LABEL:
		    break;
		  case SYM_RESTRICT:
		    break;
		  case SYM_BAD:
		    break;
		  }
	    }
	  else
	    {
#ifdef show_database_evaluate_expression
	      printf("!!!!! symbol=0 !!!!!!!! prozkoumat\n");
#endif
	    }
		return ;
	case EXPR_BINOP:
	  do_expression(expr->left);
	  do_expression(expr->right);
		return ;
	case EXPR_LOGICAL:
		return ;
	case EXPR_COMMA:
		return ;
	case EXPR_COMPARE:
		return ;
	case EXPR_ASSIGNMENT:
		return ;
	case EXPR_PREOP:
	  do_expression(expr->unop);
		return ;
	case EXPR_POSTOP:
		return ;
	case EXPR_CAST:
#if 0
	  printf("cast at %s %d:%d\n",
		 stream_name(expr->pos.stream),
		 expr->pos.line,
		 expr->pos.pos
		 );
#endif
	case EXPR_IMPLIED_CAST:
		return ;
	case EXPR_SIZEOF:
		return ;
	case EXPR_PTRSIZEOF:
		return ;
	case EXPR_ALIGNOF:
		return ;
	case EXPR_DEREF:
		return ;
	case EXPR_CALL:
		return ;
	case EXPR_SELECT:
	case EXPR_CONDITIONAL:
		return ;
	case EXPR_STATEMENT:
	  do_statement(expr->statement,0);
		return ;
	case EXPR_LABEL:
		return ;
	case EXPR_TYPE:
	        return;
	/* These can not exist as stand-alone expressions */
	case EXPR_INITIALIZER:
	case EXPR_IDENTIFIER:
	case EXPR_INDEX:
	case EXPR_POS:
	  return;
	case EXPR_SLICE:
	  return;
	}
	return ;
}



static void do_compound(struct statement* stmt, int level)
{
  if (!stmt) return;
  if ( stmt->type != STMT_COMPOUND) return;
#ifdef PRINT_DEBUG
  printf("compound\n");
#endif
  struct statement* st;

  FOR_EACH_PTR(stmt->stmts, st) {
    do_statement(st,level+1);
  } END_FOR_EACH_PTR(st);
}


#if 0 /* do function implementation */
static void do_function(struct symbol* sym)
{
#ifdef PRINT_DEBUG
  printf("do function\n");
#endif
  act_fn=sym;
#if 1
  if (sym->ctype.base_type && sym->ctype.base_type->arguments)
    {
      struct symbol* s;
      if (sym->ctype.base_type)
	{
	  FOR_EACH_PTR(sym->ctype.base_type->arguments, s) {
	    add_variable_dec(act_fn,s);
	  } END_FOR_EACH_PTR(s);
	}
    }
#endif

#if 1
  // vypise statement dane funkce
  if (sym->ctype.base_type)
    {
      if (sym->ctype.base_type->stmt)
	{
	  do_statement(sym->ctype.base_type->stmt,0);
	}
      else
	{
	  ; //printf("no statement\n");
	}
    }
#endif


#if 0
  if (sym->ident && sym->ident->symbols)
    {
      printf("\n\n%s ... start ident-symbols\n",sym->ident->name);
      struct symbol* s;
      int i=0;
      for( s=sym->ident->symbols; s; s=s->next_id) {
	if (sym->ident)
	  printf("%d symbol=%s\n",i++,s->ident->name);
      }
      printf("end print ident symbols\n");
    }
  else
    {
      printf("%s ... no symbols\n",sym->ident->name);
    }
#endif

#if 0
  // vypise symboly ve scope pro danou funkci
  if (sym->scope && sym->scope->symbols)
    {
      printf("%s ... start scope\n",sym->ident->name);
      struct symbol* s;
      int i=0;
      FOR_EACH_PTR(sym->scope->symbols, s) {
	if (sym->ident)
	  printf("%d symbol in scope=%s\n\tfile=%s at %d:%d\n",i++,s->ident->name,stream_name(s->pos.stream),s->pos.line,s->pos.pos);
	else
	  printf("no ident of symbol in scope\n");
      } END_FOR_EACH_PTR(s);
      printf("end print scope\n");
    }
  else
    {
      printf("%s ... no scope\n",sym->ident->name);
    }
#endif
  act_fn=0;
}

#endif /* do_function implementation */

#endif 


