/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#define IDENT_NAME(x) local_var_use_ ## x

struct IDENT_NAME(remember_declaration)
{
  int set;
  struct position dec;
};

static struct IDENT_NAME(remember_declaration) IDENT_NAME(decl);

static const char* IDENT_NAME(file);
static int         IDENT_NAME(line);
static int         IDENT_NAME(pos);
static int         IDENT_NAME(inside_fn);

static int IDENT_NAME(function_printed);
static struct position IDENT_NAME(nothing_position);

static void IDENT_NAME(var_use_remember)  (struct symbol* s, struct expression* ex)
{
  if (!ex || !ex->symbol || !ex->symbol->ident )         return; 

  if (  IDENT_NAME(decl) .set )
    {
      if ( IDENT_NAME(decl)  .dec .stream == ex->symbol->pos . stream
	   && IDENT_NAME(decl) .dec .line == ex->symbol->pos . line
	   && IDENT_NAME(decl) .dec .pos  == ex->symbol->pos . pos
	   )
	WRITE7 ( ex->symbol->ident->name
	       , (stream_name(ex->pos.stream))
	       , ex->pos.line
	       , ex->pos.pos
	       , stream_name(IDENT_NAME(decl)  .dec .stream)
	       , IDENT_NAME(decl)  .dec .line
	       , IDENT_NAME(decl)  .dec .pos
	       );
    }
}

static void IDENT_NAME(var_dec_remember)  (struct symbol* fn, struct symbol* s)
{
  if (!s)                                              return;
  if (!s->ident)                                       return;

  if (s->pos.line!=IDENT_NAME(line))                   return;
  if (s->pos.pos > IDENT_NAME(pos))                      return;
  if (strcmp (IDENT_NAME(file),stream_name(s->pos.stream))) return;
  if (s->pos.pos+strlen(s->ident->name)<IDENT_NAME(pos)) return;
  
  IDENT_NAME(decl) .set  = 1;
  IDENT_NAME(decl) .dec  = s->pos ;
  
  return ;
}


static void IDENT_NAME(nothing_at)        (struct position pos)
{
  IDENT_NAME(nothing_position)=pos;
}

static void IDENT_NAME(symbol_at) (struct symbol* s) 
{
  static struct symbol* p;
  if (IDENT_NAME(function_printed)) goto end;
  if (!s && p) { 
    goto ok; 
  }
  if (!p && s) { 
    if (s && strcmp(stream_name(s->pos.stream),IDENT_NAME(file))) return;
    p=s;  
    return; 
  }

  if (!s && !p ) return; // napr. spatne zadany soubor
  //  if (!prev) goto end;
  if (s->ctype.base_type && s->ctype.base_type->type==SYM_FN)
    {
      if (s->pos.line>IDENT_NAME(line))
	if(p && p->pos.line<=IDENT_NAME(line))
	  {
	  ok:
	    IDENT_NAME(inside_fn)=1;
	    add_function(var_use, output_variable_use, 0);
	    
	    IDENT_NAME(function_printed)++;
	    if (p) /* chci tisknout predchozi funkci */
		 if (!(
		     IDENT_NAME(nothing_position).line < IDENT_NAME(line) 
		     ||( IDENT_NAME(nothing_position).line==IDENT_NAME(line)
			 && IDENT_NAME(nothing_position).pos < IDENT_NAME(pos))
		     )) /* nechci aby tisklo funkci pokud jsem je jiz ukoncena */
		   //  traverse_function(p,IDENT_NAME(line),IDENT_NAME(pos));
		   walk_function(p); // projde sparse strom a vytiskne jen to co potrebuji
	  }
      p=s;
    }
 end:
  ;
}







void get_local_var_use(const char* file,
				unsigned int line,
				unsigned int pos
				)
{
  add_push();

  char* f = malloc ( strlen(file) +1 );
  strcpy(  f, file);

  IDENT_NAME(inside_fn)   = 0;
  IDENT_NAME(file) = f;
  IDENT_NAME(line) = line;
  IDENT_NAME(pos)  = pos;

  add_function(var_dec  
	       , IDENT_NAME(var_dec_remember)/*output_variable_dec*/
	       , 0  );
  add_function(var_use
	       , IDENT_NAME(var_use_remember)
	       , 0  );

  add_function(symbol_at
	       , IDENT_NAME(symbol_at) 
	       , 0);
  add_function(nothing_at
	       , IDENT_NAME(nothing_at)
	       , 0);

  spotsparse_file(f);
    
  free(f);
  add_pop();
}

#undef IDENT_NAME

