/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#define IDENT_NAME(x) used_by_ ## x

static const char* IDENT_NAME(file);
static int         IDENT_NAME(line);
static int         IDENT_NAME(pos);
static int         IDENT_NAME(inside_fn);

static int IDENT_NAME(function_printed);


/* static int IDENT_NAME(cond_output) (struct symbol* fn, struct expression* ex)            */
/* { */
/*   static int include_end; */
/*   if ( IDENT_NAME(function_printed))  */
/*     return 0; */
/*   if  (!include_end /\* && !IDENT_NAME(local_only)  *\/ */
/*        && strcmp(stream_name(ex->pos.stream), */
/* 		 IDENT_NAME(file))) */
/*     //	 neni z tohoto souboru */
/*     return 1; */
/*   if (!strcmp(stream_name(ex->pos.stream),IDENT_NAME(file))) */
/*     { */
/*       include_end=1; */
/*       if ( ( IDENT_NAME(inside_fn) || !fn ) */
/* 	   && (  */
/* 	       ex->pos.line < IDENT_NAME(line)  ||  */
/* 	       ( ex->pos.line==IDENT_NAME(line)  */
/* 		 && ex->pos.pos<=IDENT_NAME(pos)  */
/* 		 ))) */
/* 	{ */
/* 	  return 1; */
/* 	} */
/*     } */
/*   return 0; */
/* } */

static struct position IDENT_NAME(nothing_position);

static void IDENT_NAME(nothing_at)        (struct position pos)
{
  IDENT_NAME(nothing_position)=pos;
}

static void IDENT_NAME(symbol_at) (struct symbol* s) 
{
  //  printf("1\n");
  static struct symbol* p;
  if (IDENT_NAME(function_printed)) return;
  //  printf("2\n");
  if (!s && p) { 
    goto ok; 
  }
  //  printf("3\n");
  if (!p && s) { 
    if (s && strcmp(stream_name(s->pos.stream),IDENT_NAME(file))) return;
    p=s;  
    return; 
  }
  //  printf("4\n");

  if (!s && !p ) return; // napr. spatne zadany soubor
  //  printf("5\n");
  //  if (!prev) goto end;
  if (s->ctype.base_type && s->ctype.base_type->type==SYM_FN)
    {
      //      printf("6\n");
      if (s->pos.line>IDENT_NAME(line))	{
	//	  printf("7\n");
	  if(p && p->pos.line<=IDENT_NAME(line))  {
	    //	    printf("8\n");
	    ok:
/* 	    printf("printing %s %d:%d\n" */
/* 		   ,stream_name(p->pos.stream) */
/* 		   ,p->pos.line */
/* 		   ,p->pos.pos */
/* 		   ); */

	    IDENT_NAME(inside_fn)=1;
	    add_function(var_use, output_variable_use, 0);
	    
	    if (p) { /* chci tisknout predchozi funkci */
	      if (!(IDENT_NAME(nothing_position).line < IDENT_NAME(line) 
		    ||( IDENT_NAME(nothing_position).line==IDENT_NAME(line)
			&& IDENT_NAME(nothing_position).pos < IDENT_NAME(pos))
		    )) /* nechci aby tisklo funkci pokud jsem je jiz ukoncena */
		
		{
		  traverse_function(p
				    , 0 /* will print entire function */
				    //, IDENT_NAME(line) /* will print just previous parts */
				    ,IDENT_NAME(pos));
		  //		  walk_function(p); // projde sparse strom a vytiskne jen to co potrebuji
		}
	    }
	    IDENT_NAME(function_printed)++;
	    //	    printf("printing end\n");
	    add_function(var_use, 0, 0);
	    
	  }
      }
      p=s;
    }
}

void get_used_by_function_at(const char* filename, int line, int pos)
{
  add_push();
  char* f = malloc ( strlen(filename) +1 );
  strcpy(  f, filename);

  IDENT_NAME(inside_fn)   = 0;
  IDENT_NAME(file) = f;
  IDENT_NAME(line) = line;
  IDENT_NAME(pos)  = pos;

  add_function(symbol_at
	       , IDENT_NAME(symbol_at) 
	       , 0);
  add_function(nothing_at
	       , IDENT_NAME(nothing_at)
	       , 0);

  /*   add_function(var_use,    output_variable_use, IDENT_NAME(cond_output) ); */

  spotsparse_file(f);

  free(f);
  add_pop();
  return;

}
#undef IDENT_NAME

