/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#define IDENT_NAME(x) all_ ## x

static const char* IDENT_NAME(file);
static int         IDENT_NAME(line);
static int         IDENT_NAME(pos);
static int         IDENT_NAME(inside_fn);
static int         IDENT_NAME(local_only);


void IDENT_NAME(symbol_at) (struct symbol* s)
{
  static int function_printed;
  static struct symbol* p;

  if (function_printed) goto end;
  if (!s && p) { 
    goto ok; 
  }
  if (!p && s) { 
    if (s && strcmp(stream_name(s->pos.stream),IDENT_NAME(file))) return;
    p=s;  
    return; 
  }
  if (!s && !p ) return; // napr. spatne zadany soubor
  if (s->ctype.base_type && s->ctype.base_type->type==SYM_FN)
    {
      if (s->pos.line>IDENT_NAME(line))
	  if(p && p->pos.line<=IDENT_NAME(line))
	   {
	   ok:
	     IDENT_NAME(inside_fn)=1;
	     add_function(var_dec
			  , output_variable_dec
			  , cond_output_variable_dec);
	     function_printed++;
	     if (p)    traverse_function(p,IDENT_NAME(line),IDENT_NAME(pos));
	   }
      p=s;
    }
 end:
  ;
}

void get_visible_at(const char* file,
				unsigned int line,
				unsigned int pos,
				int local_only
				)
{
  add_push();
  char* f = malloc ( strlen(file) +1 );
  strcpy(  f, file);

  IDENT_NAME(inside_fn)   = 0;
  IDENT_NAME(local_only) = local_only;
  IDENT_NAME(file) = f;
  IDENT_NAME(line) = line;
  IDENT_NAME(pos)  = pos;

  add_function(var_dec,    output_variable_dec, variable_dec_cond_output );
  add_function(mac_def,    output_macro_define, macro_def_cond_output    );
  add_function(fce_dec,    output_function_dec, fn_dec_cond_output       );
  add_function(fce_inline, output_function_dec, fn_dec_cond_output       );
  add_function(fce_def,    output_function_dec, fn_dec_cond_output       );

  add_function(symbol_at, IDENT_NAME(symbol_at) , 0);

  spotsparse_file(f);

  free(f);
  add_pop();
}

#undef IDENT_NAME

