/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#define IDENT_NAME(x) macro_def_ ## x

static const char* IDENT_NAME(file);
static int         IDENT_NAME(line);
static int         IDENT_NAME(pos);
static int         IDENT_NAME(local_only);

static int IDENT_NAME(cond_output)   (struct symbol* s)
{
  static int include_end;
  if  (!include_end && ! IDENT_NAME(local_only) 
       && strcmp(stream_name(s->pos.stream),
		 IDENT_NAME(file)))
    {
      /* neni z tohoto souboru */
      return 1;
    }
  if (!strcmp(stream_name(s->pos.stream)
	      , IDENT_NAME(file)) )
    {
      include_end=1;      
      if ( 
	  s->pos.line < IDENT_NAME(line)  || 
	  ( s->pos.line==IDENT_NAME(line)
	    && s->pos.pos<=IDENT_NAME(pos)
	    ))
	{
	  /* je definovano pred pozadovanym mistem */
	  return 1;
	}
    }
  return 0;
}


void get_visible_preprocess_at(const char* file, 
			       unsigned int line, 
			       unsigned int pos, 
			       int local_only
			       )
{
  add_push();
  char* f = malloc ( strlen(file) +1 );
  strcpy(  f, file);

  add_function(mac_def
	       , output_macro_define
	       , IDENT_NAME(cond_output) );

  IDENT_NAME(local_only) = local_only;
  IDENT_NAME(file) = f;
  IDENT_NAME(line) = line;
  IDENT_NAME(pos)  = pos;

  spotsparse_file(f);

  free(f);
  add_pop();
  return;
}
#undef IDENT_NAME
