/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

//#define DEBUG_PRINT

#define IDENT_NAME(x) variable_dec_ ## x

static const char* IDENT_NAME(file);
static int         IDENT_NAME(line);
static int         IDENT_NAME(pos);
static int         IDENT_NAME(inside_fn);
static int         IDENT_NAME(local_only);

static int IDENT_NAME(cond_output)   (struct symbol* fn, struct symbol* s)
{
  static int include_end;
  if  (!include_end && !IDENT_NAME(local_only) 
       && strcmp(stream_name(s->pos.stream),
		 IDENT_NAME(file)))
    //	 neni z tohoto souboru
    return 1;
  if (!strcmp(stream_name(s->pos.stream),IDENT_NAME(file)))
    {
      include_end=1;
      if ( ( IDENT_NAME(inside_fn) || !fn )
	   && ( 
	       s->pos.line < IDENT_NAME(line)  || 
	       ( s->pos.line==IDENT_NAME(line) 
		 && s->pos.pos<=IDENT_NAME(pos) 
		 )))
	{
	  /* 
	     je deklarovano pred pozadovanym mistem a mimo funkci
	  */
	  return 1;
	}
    }
  return 0;
}

static int IDENT_NAME(function_printed);
static struct position IDENT_NAME(nothing_position);

static void IDENT_NAME(nothing_at)        (struct position pos)
{
  IDENT_NAME(nothing_position)=pos;
}

static void IDENT_NAME(symbol_at) (struct symbol* s) 
{
  static struct symbol* p;
#ifdef DEBUG_PRINT
  printf("called %p %p\n",s,p);
#endif

  if (IDENT_NAME(function_printed)) goto end;
  if (!s && p) { 
#ifdef DEBUG_PRINT
    printf("last\n");       
#endif
    goto ok; 
  }
  if (!p && s) { 
#ifdef DEBUG_PRINT
    printf("frst\n"); 
#endif
    if (s && strcmp(stream_name(s->pos.stream),IDENT_NAME(file))) return;
    p=s;  
    return; 
  }

  if (!s && !p ) return; // napr. spatne zadany soubor
  //  if (!prev) goto end;
  if (s->ctype.base_type && s->ctype.base_type->type==SYM_FN)
    {
#ifdef DEBUG_PRINT
      printf("fce at %s %d:%d \n",stream_name(s->pos.stream),s->pos.line,s->pos.pos);
#endif
      if (s->pos.line>IDENT_NAME(line))
	{
	  if(p && p->pos.line<=IDENT_NAME(line))
	   {
	   ok:
#ifdef DEBUG_PRINT
	     printf("traverse... %d:%d\n",p->pos.line,p->pos.pos);
#endif
	     IDENT_NAME(inside_fn)=1;
	     add_function(var_dec
			  , output_variable_dec
			  , IDENT_NAME(cond_output));

	     IDENT_NAME(function_printed)++;
	     if (p) /* chci tisknout predchozi funkci */
	       {
		 if (!(
		     IDENT_NAME(nothing_position).line < IDENT_NAME(line) 
		     ||( IDENT_NAME(nothing_position).line==IDENT_NAME(line)
			 && IDENT_NAME(nothing_position).pos < IDENT_NAME(pos))
		     )) /* nechci aby tisklo funkci pokud jsem je jiz ukoncena */
		   traverse_function(p,IDENT_NAME(line),IDENT_NAME(pos));
#ifdef DEBUG_PRINT
		 else
		   printf("p = %p ale jiz ukonceno na %s %d:%d\n"
			  , p
			  , stream_name(IDENT_NAME(nothing_position).stream)
			  , IDENT_NAME(nothing_position).line
			  , IDENT_NAME(nothing_position).pos);
#endif
	       }
#ifdef DEBUG_PRINT
	     else       
	       printf("p = nil\n");
#endif
	   }
	 else 
	   {
#ifdef DEBUG_PRINT
	     printf("p->pos.line > IDENT ## _line %d < %d\n",p->pos.line ,IDENT_NAME(line));
#endif
	   }
	}
      else
	{
#ifdef DEBUG_PRINT
	  printf("s->pos.line <= IDENT ## _line %d < %d\n",s->pos.line ,IDENT_NAME(line));
#endif
	}
      p=s;
    }
 end:
  ;
}

void get_visible_variable_at(const char* filename
			     , int line
			     , int pos
			     , int local_only)
{
  add_push();

  char* f = malloc ( strlen(filename) +1 );
  strcpy(  f, filename);

  IDENT_NAME(inside_fn)   = 0;
  IDENT_NAME(local_only) = local_only;
  IDENT_NAME(file) = f;
  IDENT_NAME(line) = line;
  IDENT_NAME(pos)  = pos;

  add_function(var_dec
	       , output_variable_dec
	       , IDENT_NAME(cond_output) );
  add_function(symbol_at
	       , IDENT_NAME(symbol_at) 
	       , 0);
  add_function(nothing_at
	       , IDENT_NAME(nothing_at)
	       , 0);

  spotsparse_file( f );

  free(f);
  add_pop();
  return;
}

#undef IDENT_NAME
