/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

/*
  deklaruje symboly cspot ktere pouziva sparse
 */
#include "sparse/symbol.h"
#include "sparse/expression.h"
#include "sparse/token.h"
#include "sparse/lib.h"
#include "sparse/allocate.h"
#include "sparse/token.h"
#include "sparse/parse.h"
#include "sparse/symbol.h"
#include "sparse/expression.h"
#include "sparse/linearize.h"
#include "sparse/scope.h"

#include <stdio.h>

#define PRE_BUF_SIZE (1<<15)

struct symbol  *act_fn;
const  char    *additional_includepath[MAX_ADDITIONAL_INCLUDE];
const  char    *additional_system_includepath[MAX_ADDITIONAL_INCLUDE];
char           *pre_buffer;
int             pre_buffer_allocated;
int             verbose_spot;
int             running_init;

FILE           *sparse_output;

/* volana kdykoli je nalezeno pouziti funkce = predavani jako odkaz + volani + prirazeni */
void (*add_function_use)         (struct symbol* act_fn, struct expression *expr) ;
/* volana narazili parser na definici fuknce */
void (*add_function_def)         (struct symbol* )                                ;
/* volana narazili parser na definici inline fuknce */
void (*add_function_inline)      (struct symbol* )                                ;
/* volana narazili parser na deklaraci fuknce */
void (*add_function_dec)         (struct symbol* )                                ;
/* volana narazili parser na deklaraci staticke promenne */
void (*add_static_variable_dec)  (struct symbol*, struct symbol* )                ;
/* volana narazili parser na deklaraci promenne */
void (*add_variable_dec)         (struct symbol*, struct symbol* )                ;
/* volana narazili parser na pouziti promenne - v parametrech, prirazeni, volani (jde li o promennou typu funkce) */
void (*add_variable_use)         (struct symbol*, struct expression* )            ;
/* volana narazili parser na include direktivu */
void (*add_include)              (const char* , struct token* )                   ;
/* volana narazili parser na definici makra */
void (*add_macro_define)         (struct symbol* )                                ;
/* volana narazili parser na pouziti makra - a to i po rozvinuti , stejne tak v direktive defined */
void (*add_macro_use)            (struct symbol*, struct token* )                 ;
void (*add_struct_dec)           (struct symbol* )                                ;
void (*add_struct_def)           (struct symbol* )                                ;
void (*add_struct_use)           (struct token* , struct position* )              ;
void (*add_union_dec)            (struct symbol* )                                ;
void (*add_union_def)            (struct symbol* )                                ;
void (*add_union_use)            (struct token* , struct position* )              ;
void (*add_typedef_)             (struct symbol* )                                ;
/* pouziti typedefu = pouziti v deklaraci, v pretypovani*/
void (*add_typedef_use)          (struct symbol* , struct position*)              ;
/* volana kdykoli parser narazi na symbol - urceno hlavne pro ziskani definice funkce na dane pozici */
void (*add_symbol_at)            (struct symbol*)                                 ;
/* volana narazi-li parser na konec symbolu (zatim pouze funkce koncova '}' )*/
void (*add_nothing_at)           (struct position )                               ;
/* volana pro vyhodnoceni vyrazu - priklad: pouziti funkce, promenne -> ulozeni */
void (*add_evaluate_expression)  (struct symbol*, struct expression *)            ;
/* volana pro vyhodnoceni prikazu pretypovani */
void (*add_cast)                 (struct expression *)                            ;

void (*add_struct_member)        (struct expression *)                            ;

/* volana narazili parser na undef makra */
void (*add_macro_undef)          (struct token* )                                 ;

//void (*add_macro_defined)        (struct token* )                                 ;

void init_interface()
{
  //  set_macros_file("");
  static char init_buffer[PRE_BUF_SIZE];
  pre_buffer=init_buffer;
  pre_buffer_allocated=PRE_BUF_SIZE;
  sparse_output = 0;
}

