/*
 *
 *	(c) Petr Susil 2006 <susa@atrey.karlin.mff.cuni.cz>
 *
 *	This software may be freely distributed and used according to the terms
 *	of the GNU General Public License.
 */

#ifndef GREP_H
#define GREP_H
#include "sparse/symbol.h"
#include "sparse/token.h"

void output_typedef_      (struct symbol* );
void output_struct_dec    (struct symbol* );
void output_macro_defined (struct token*  );
void output_macro_define  (struct symbol* );
void output_include       (const char* filename, struct token* token);
void output_macro_use     (struct symbol* sym, struct token* token);
void output_variable_dec  (struct symbol* fn, struct symbol* s);
void output_variable_use  (struct symbol* fn, struct expression* ex);
void output_function_use (struct symbol* sym, struct expression* ex);
void output_function_dec  (struct symbol* sym);

int (*cond_output_typedef_      ) (struct symbol* );
int (*cond_output_struct_dec    ) (struct symbol* );
int (*cond_output_macro_defined ) (struct token*  );
int (*cond_output_macro_define  ) (struct symbol* );
int (*cond_output_include       ) (const char* filename, struct token* token);
int (*cond_output_macro_use     ) (struct symbol* sym, struct token* token);
int (*cond_output_variable_dec  ) (struct symbol* fn, struct symbol* s);
int (*cond_output_variable_use  ) (struct symbol* fn, struct expression* ex);
int (*cond_output_function_use  ) (struct symbol* sym, struct expression* ex);
int (*cond_output_function_dec  ) (struct symbol* sym);
int (*cond_output_function_def  ) (struct symbol* sym);
int (*cond_output_function_include ) (struct symbol* sym);
int (*cond_output_function_inline  ) (struct symbol* sym);

void output_null();
void output_init();
void output_functions();
#define output_function(x,y) add_ ## x = output_ ## x; cond_output_ ## x = y;
#endif
